
/*
 * This is an auto-generated file.
 * Do not edit! All changes made to it will be lost.
 */


#include <entities.h>
#include <storage/datastore.h>
#include <storage/selectquerybuilder.h>
#include <utils.h>

#include <qsqldatabase.h>
#include <QLatin1String>
#include <qsqlquery.h>
#include <qsqlerror.h>
#include <qvariant.h>
#include <QtCore/QHash>
#include <QtCore/QMutex>

using namespace Akonadi;



// private class
class SchemaVersion::Private : public QSharedData
{
  public:
    Private() : QSharedData()
    
      , version( 0 )
    
      , version_changed( false )
    
    {}

    
    int version;
    
    bool version_changed : 1;
    

    static void addToCache( const SchemaVersion & entry );

    // cache
    static bool cacheEnabled;
    static QMutex cacheMutex;
    
};


// static members
bool SchemaVersion::Private::cacheEnabled = false;
QMutex SchemaVersion::Private::cacheMutex;



void SchemaVersion::Private::addToCache( const SchemaVersion & entry )
{
  Q_ASSERT( cacheEnabled );
  Q_UNUSED( entry ); 
  cacheMutex.lock();
  
  cacheMutex.unlock();
}


// constructor
SchemaVersion::SchemaVersion() : Entity(),
  d( new Private )
{
}

SchemaVersion::SchemaVersion(
  int version
) :
  Entity(),
  d( new Private )
{

  d->version = version;
  d->version_changed = true;

}

SchemaVersion::SchemaVersion( const SchemaVersion & other )
  : Entity( other ), d( other.d )
{
}

// destructor
SchemaVersion::~SchemaVersion() {}

// assignment operator
SchemaVersion& SchemaVersion::operator=( const SchemaVersion & other )
{
  if ( this != &other ) {
    d = other.d;
    setId( other.id() );
  }
  return *this;
}

// comparisson operator
bool SchemaVersion::operator==( const SchemaVersion & other )
{
  return id() == other.id();
}

// accessor methods
int SchemaVersion::version() const
{
  return d->version;
}

void SchemaVersion::
setVersion( int version )

{
  d->version = version;
  d->version_changed = true;
}



// SQL table information
QString SchemaVersion::tableName()
{
  return QLatin1String( "SchemaVersionTable" );
}

QStringList SchemaVersion::columnNames()
{
  QStringList rv;
  
  rv.append( QLatin1String( "version" ) );
  
  return rv;
}

QStringList SchemaVersion::fullColumnNames()
{
  QStringList rv;
  
  rv.append( QLatin1String( "SchemaVersionTable.version" ) );
  
  return rv;
}


QString SchemaVersion::versionColumn()
{
  return QLatin1String( "version" );
}

QString SchemaVersion::versionFullColumnName()
{
  return tableName() + QLatin1String( ".version" );
}



// count records
int SchemaVersion::count( const QString &column, const QVariant &value )
{
  return Entity::count<SchemaVersion>( column, value );
}

// check existence



// result extraction
QVector< SchemaVersion > SchemaVersion::extractResult( QSqlQuery & query )
{
  QVector<SchemaVersion> rv;
  while ( query.next() ) {
    rv.append( SchemaVersion(
      
        (query.isNull(0)) ?
          int() :
          
          query.value( 0 ).value<int>()
            
    ) );
  }
  return rv;
}

// data retrieval


QVector<SchemaVersion> SchemaVersion::retrieveAll()
{
  QSqlDatabase db = DataStore::self()->database();
  if ( !db.isOpen() )
    return QVector<SchemaVersion>();

  QSqlQuery query( db );
  QString statement = QLatin1String( "SELECT version FROM " );
  statement.append( tableName() );
  query.prepare( statement );
  if ( !query.exec() ) {
    qDebug() << "Error during selection of all records from table" << tableName()
      << query.lastError().text();
    return QVector<SchemaVersion>();
  }
  return extractResult( query );
}

QVector<SchemaVersion> SchemaVersion::retrieveFiltered( const QString &key, const QVariant &value )
{
  QSqlDatabase db = DataStore::self()->database();
  if ( !db.isOpen() )
    return QVector<SchemaVersion>();

  SelectQueryBuilder<SchemaVersion> qb;
  if ( value.isNull() )
    qb.addValueCondition( key, Query::Is, QVariant() );
  else
    qb.addValueCondition( key, Query::Equals, value );
  if ( !qb.exec() ) {
    qDebug() << "Error during selection of records from table" << tableName()
      << "filtered by" << key << "=" << value
      << qb.query().lastError().text();
    return QVector<SchemaVersion>();
  }
  return qb.result();
}

// data retrieval for referenced tables


// data retrieval for inverse referenced tables


// debug stream operator
QDebug & operator<<( QDebug& d, const SchemaVersion& entity )
{
  d << "[SchemaVersion: "
  
    << "version = " << entity.version()
    
    << "]";
  return d;
}

// inserting new data
bool SchemaVersion::insert( qint64* insertId )
{
  QSqlDatabase db = DataStore::self()->database();
  if ( !db.isOpen() )
    return false;

  QueryBuilder qb( tableName(), QueryBuilder::Insert );
  
    if ( d->version_changed )
      qb.setColumnValue( versionColumn(), this->version() );
    

  if ( !qb.exec() ) {
    qDebug() << "Error during insertion into table" << tableName()
      << qb.query().lastError().text();
    return false;
  }

  setId( qb.insertId() );
  if ( insertId )
    *insertId = id();
  return true;
}

bool SchemaVersion::hasPendingChanges() const
{
  return false
  
    || d->version_changed
  ;
}

// update existing data
bool SchemaVersion::update()
{
  invalidateCache();
  QSqlDatabase db = DataStore::self()->database();
  if ( !db.isOpen() )
    return false;

  QString statement = QLatin1String( "UPDATE " );
  statement += tableName();
  statement += QLatin1String( " SET " );

  QStringList cols;
  
    if ( d->version_changed )
      cols.append( versionColumn() + QLatin1String( " = :version" ) );;
  
  statement += cols.join( QLatin1String( ", " ) );
  

  QSqlQuery query( db );
  query.prepare( statement );
  
    if ( d->version_changed ) {
      
        query.bindValue( QLatin1String(":version"), this->version() );
    }
  
  if ( !query.exec() ) {
    qDebug() << "Error during updating record with id" << id()
             << " in table" << tableName() << query.lastError().text();
    return false;
  }
  return true;
}

// delete records
bool SchemaVersion::remove( const QString &column, const QVariant &value )
{
  invalidateCompleteCache();
  return Entity::remove<SchemaVersion>( column, value );
}



// cache stuff
void SchemaVersion::invalidateCache() const
{
  if ( Private::cacheEnabled ) {
    Private::cacheMutex.lock();
    
    Private::cacheMutex.unlock();
  }
}

void SchemaVersion::invalidateCompleteCache()
{
  if ( Private::cacheEnabled ) {
    Private::cacheMutex.lock();
    
    Private::cacheMutex.unlock();
  }
}

void SchemaVersion::enableCache( bool enable )
{
  Private::cacheEnabled = enable;
}



// private class
class Resource::Private : public QSharedData
{
  public:
    Private() : QSharedData()
    
      , name()
    
      , isVirtual( false )
    
      , name_changed( false )
    
      , isVirtual_changed( false )
    
    {}

    
    QString name;
    
    bool isVirtual : 1;
    
    bool name_changed : 1;
    
    bool isVirtual_changed : 1;
    

    static void addToCache( const Resource & entry );

    // cache
    static bool cacheEnabled;
    static QMutex cacheMutex;
    
    static QHash<qint64, Resource > idCache;
    
    static QHash<QString, Resource > nameCache;
    
};


// static members
bool Resource::Private::cacheEnabled = false;
QMutex Resource::Private::cacheMutex;

QHash<qint64, Resource > Resource::Private::idCache;

QHash<QString, Resource > Resource::Private::nameCache;



void Resource::Private::addToCache( const Resource & entry )
{
  Q_ASSERT( cacheEnabled );
  Q_UNUSED( entry ); 
  cacheMutex.lock();
  
  idCache.insert( entry.id(), entry );
  
  nameCache.insert( entry.name(), entry );
  
  cacheMutex.unlock();
}


// constructor
Resource::Resource() : Entity(),
  d( new Private )
{
}

Resource::Resource(
  const QString &name, bool isVirtual
) :
  Entity(),
  d( new Private )
{

  d->name = name;
  d->name_changed = true;

  d->isVirtual = isVirtual;
  d->isVirtual_changed = true;

}

Resource::Resource(
  qint64 id, const QString &name, bool isVirtual
) :
  Entity( id ),
  d( new Private )
{

  d->name = name;
  d->name_changed = true;

  d->isVirtual = isVirtual;
  d->isVirtual_changed = true;

}
Resource::Resource( const Resource & other )
  : Entity( other ), d( other.d )
{
}

// destructor
Resource::~Resource() {}

// assignment operator
Resource& Resource::operator=( const Resource & other )
{
  if ( this != &other ) {
    d = other.d;
    setId( other.id() );
  }
  return *this;
}

// comparisson operator
bool Resource::operator==( const Resource & other )
{
  return id() == other.id();
}

// accessor methods
QString Resource::name() const
{
  return d->name;
}

void Resource::
setName( const QString &name )

{
  d->name = name;
  d->name_changed = true;
}

bool Resource::isVirtual() const
{
  return d->isVirtual;
}

void Resource::
setIsVirtual( bool isVirtual )

{
  d->isVirtual = isVirtual;
  d->isVirtual_changed = true;
}



// SQL table information
QString Resource::tableName()
{
  return QLatin1String( "ResourceTable" );
}

QStringList Resource::columnNames()
{
  QStringList rv;
  
  rv.append( QLatin1String( "id" ) );
  
  rv.append( QLatin1String( "name" ) );
  
  rv.append( QLatin1String( "isVirtual" ) );
  
  return rv;
}

QStringList Resource::fullColumnNames()
{
  QStringList rv;
  
  rv.append( QLatin1String( "ResourceTable.id" ) );
  
  rv.append( QLatin1String( "ResourceTable.name" ) );
  
  rv.append( QLatin1String( "ResourceTable.isVirtual" ) );
  
  return rv;
}


QString Resource::idColumn()
{
  return QLatin1String( "id" );
}

QString Resource::idFullColumnName()
{
  return tableName() + QLatin1String( ".id" );
}

QString Resource::nameColumn()
{
  return QLatin1String( "name" );
}

QString Resource::nameFullColumnName()
{
  return tableName() + QLatin1String( ".name" );
}

QString Resource::isVirtualColumn()
{
  return QLatin1String( "isVirtual" );
}

QString Resource::isVirtualFullColumnName()
{
  return tableName() + QLatin1String( ".isVirtual" );
}



// count records
int Resource::count( const QString &column, const QVariant &value )
{
  return Entity::count<Resource>( column, value );
}

// check existence

bool Resource::exists( qint64 id )
{
  if ( Private::cacheEnabled ) {
    Private::cacheMutex.lock();
    if ( Private::idCache.contains( id ) ) {
      Private::cacheMutex.unlock();
      return true;
    }
    Private::cacheMutex.unlock();
  }
  return count( idColumn(), id ) > 0;
}

bool Resource::exists( const QString &name )
{
  if ( Private::cacheEnabled ) {
    Private::cacheMutex.lock();
    if ( Private::nameCache.contains( name ) ) {
      Private::cacheMutex.unlock();
      return true;
    }
    Private::cacheMutex.unlock();
  }
  return count( nameColumn(), name ) > 0;
}



// result extraction
QVector< Resource > Resource::extractResult( QSqlQuery & query )
{
  QVector<Resource> rv;
  while ( query.next() ) {
    rv.append( Resource(
      
        (query.isNull(0)) ?
          qint64() :
          
          query.value( 0 ).value<qint64>()
            ,
        (query.isNull(1)) ?
          QString() :
          
          Utils::variantToString( query.value( 1 ) )
            ,
        (query.isNull(2)) ?
          bool() :
          
          query.value( 2 ).value<bool>()
            
    ) );
  }
  return rv;
}

// data retrieval
Resource Resource::retrieveById( qint64 id )
{
  
  if ( Private::cacheEnabled ) {
    Private::cacheMutex.lock();
    if ( Private::idCache.contains( id ) ) {
      Private::cacheMutex.unlock();
      return Private::idCache.value( id );
    }
    Private::cacheMutex.unlock();
  }
  
  QSqlDatabase db = DataStore::self()->database();
  if ( !db.isOpen() )
    return Resource();

  QSqlQuery query( db );
  QString statement = QLatin1String( "SELECT id, name, isVirtual FROM " );
  statement.append( tableName() );
  statement.append( QLatin1String(" WHERE id = :key") );
  query.prepare( statement );
  query.bindValue( QLatin1String(":key"), id );
  if ( !query.exec() ) {
    qDebug() << "Error during selection of record with id"
      << id << "from table" << tableName()
      << query.lastError().text();
    return Resource();
  }
  if ( !query.next() ) {
    return Resource();
  }

  Resource rv(
  
    (query.isNull(0)) ?
      qint64() :
      
      query.value( 0 ).value<qint64>()
        ,
    (query.isNull(1)) ?
      QString() :
      
      Utils::variantToString( query.value( 1 ) )
        ,
    (query.isNull(2)) ?
      bool() :
      
      query.value( 2 ).value<bool>()
        
  );
  if ( Private::cacheEnabled ) {
    Private::addToCache( rv );
  }
  return rv;

}

Resource Resource::retrieveByName( const QString &name )
{
  
  if ( Private::cacheEnabled ) {
    Private::cacheMutex.lock();
    if ( Private::nameCache.contains( name ) ) {
      Private::cacheMutex.unlock();
      return Private::nameCache.value( name );
    }
    Private::cacheMutex.unlock();
  }
  
  QSqlDatabase db = DataStore::self()->database();
  if ( !db.isOpen() )
    return Resource();

  QSqlQuery query( db );
  QString statement = QLatin1String( "SELECT id, name, isVirtual FROM " );
  statement.append( tableName() );
  statement.append( QLatin1String(" WHERE name = :key") );
  query.prepare( statement );
  query.bindValue( QLatin1String(":key"), name );
  if ( !query.exec() ) {
    qDebug() << "Error during selection of record with name"
      << name << "from table" << tableName()
      << query.lastError().text();
    return Resource();
  }
  if ( !query.next() ) {
    return Resource();
  }

  Resource rv(
  
    (query.isNull(0)) ?
      qint64() :
      
      query.value( 0 ).value<qint64>()
        ,
    (query.isNull(1)) ?
      QString() :
      
      Utils::variantToString( query.value( 1 ) )
        ,
    (query.isNull(2)) ?
      bool() :
      
      query.value( 2 ).value<bool>()
        
  );
  if ( Private::cacheEnabled ) {
    Private::addToCache( rv );
  }
  return rv;

}


QVector<Resource> Resource::retrieveAll()
{
  QSqlDatabase db = DataStore::self()->database();
  if ( !db.isOpen() )
    return QVector<Resource>();

  QSqlQuery query( db );
  QString statement = QLatin1String( "SELECT id, name, isVirtual FROM " );
  statement.append( tableName() );
  query.prepare( statement );
  if ( !query.exec() ) {
    qDebug() << "Error during selection of all records from table" << tableName()
      << query.lastError().text();
    return QVector<Resource>();
  }
  return extractResult( query );
}

QVector<Resource> Resource::retrieveFiltered( const QString &key, const QVariant &value )
{
  QSqlDatabase db = DataStore::self()->database();
  if ( !db.isOpen() )
    return QVector<Resource>();

  SelectQueryBuilder<Resource> qb;
  if ( value.isNull() )
    qb.addValueCondition( key, Query::Is, QVariant() );
  else
    qb.addValueCondition( key, Query::Equals, value );
  if ( !qb.exec() ) {
    qDebug() << "Error during selection of records from table" << tableName()
      << "filtered by" << key << "=" << value
      << qb.query().lastError().text();
    return QVector<Resource>();
  }
  return qb.result();
}

// data retrieval for referenced tables


// data retrieval for inverse referenced tables

QVector<Collection> Resource::collections() const
{
  return Collection::retrieveFiltered( Collection::resourceIdColumn(), id() );
}


// debug stream operator
QDebug & operator<<( QDebug& d, const Resource& entity )
{
  d << "[Resource: "
  
    << "id = " << entity.id()
    << ", "
    << "name = " << entity.name()
    << ", "
    << "isVirtual = " << entity.isVirtual()
    
    << "]";
  return d;
}

// inserting new data
bool Resource::insert( qint64* insertId )
{
  QSqlDatabase db = DataStore::self()->database();
  if ( !db.isOpen() )
    return false;

  QueryBuilder qb( tableName(), QueryBuilder::Insert );
  
    if ( d->name_changed )
      qb.setColumnValue( nameColumn(), this->name() );
    
    if ( d->isVirtual_changed )
      qb.setColumnValue( isVirtualColumn(), this->isVirtual() );
    

  if ( !qb.exec() ) {
    qDebug() << "Error during insertion into table" << tableName()
      << qb.query().lastError().text();
    return false;
  }

  setId( qb.insertId() );
  if ( insertId )
    *insertId = id();
  return true;
}

bool Resource::hasPendingChanges() const
{
  return false
  
    || d->name_changed
  
    || d->isVirtual_changed
  ;
}

// update existing data
bool Resource::update()
{
  invalidateCache();
  QSqlDatabase db = DataStore::self()->database();
  if ( !db.isOpen() )
    return false;

  QString statement = QLatin1String( "UPDATE " );
  statement += tableName();
  statement += QLatin1String( " SET " );

  QStringList cols;
  
    if ( d->name_changed )
      cols.append( nameColumn() + QLatin1String( " = :name" ) );;
  
    if ( d->isVirtual_changed )
      cols.append( isVirtualColumn() + QLatin1String( " = :isVirtual" ) );;
  
  statement += cols.join( QLatin1String( ", " ) );
  
  statement += QLatin1String( " WHERE id = :id" );
  

  QSqlQuery query( db );
  query.prepare( statement );
  
    if ( d->name_changed ) {
      
        query.bindValue( QLatin1String(":name"), this->name() );
    }
  
    if ( d->isVirtual_changed ) {
      
        query.bindValue( QLatin1String(":isVirtual"), this->isVirtual() );
    }
  
  query.bindValue( QLatin1String(":id"), id() );
  
  if ( !query.exec() ) {
    qDebug() << "Error during updating record with id" << id()
             << " in table" << tableName() << query.lastError().text();
    return false;
  }
  return true;
}

// delete records
bool Resource::remove( const QString &column, const QVariant &value )
{
  invalidateCompleteCache();
  return Entity::remove<Resource>( column, value );
}


bool Resource::remove()
{
  invalidateCache();
  return Entity::remove<Resource>( idColumn(), id() );
}

bool Resource::remove( qint64 id )
{
  return remove( idColumn(), id );
}


// cache stuff
void Resource::invalidateCache() const
{
  if ( Private::cacheEnabled ) {
    Private::cacheMutex.lock();
    
    Private::idCache.remove( id() );
    
    Private::nameCache.remove( name() );
    
    Private::cacheMutex.unlock();
  }
}

void Resource::invalidateCompleteCache()
{
  if ( Private::cacheEnabled ) {
    Private::cacheMutex.lock();
    
    Private::idCache.clear();
    
    Private::nameCache.clear();
    
    Private::cacheMutex.unlock();
  }
}

void Resource::enableCache( bool enable )
{
  Private::cacheEnabled = enable;
}



// private class
class Collection::Private : public QSharedData
{
  public:
    Private() : QSharedData()
    
      , parentId( 0 )
    
      , resourceId( 0 )
    
      , remoteId()
    
      , remoteRevision()
    
      , name()
    
      , cachePolicyLocalParts()
    
      , queryString()
    
      , queryLanguage()
    
      , cachePolicyCheckInterval( -1 )
    
      , cachePolicyCacheTimeout( -1 )
    
      , subscribed( true )
    
      , cachePolicyInherit( true )
    
      , cachePolicySyncOnDemand( false )
    
      , remoteId_changed( false )
    
      , remoteRevision_changed( false )
    
      , name_changed( false )
    
      , parentId_changed( false )
    
      , resourceId_changed( false )
    
      , subscribed_changed( false )
    
      , cachePolicyInherit_changed( false )
    
      , cachePolicyCheckInterval_changed( false )
    
      , cachePolicyCacheTimeout_changed( false )
    
      , cachePolicySyncOnDemand_changed( false )
    
      , cachePolicyLocalParts_changed( false )
    
      , queryString_changed( false )
    
      , queryLanguage_changed( false )
    
    {}

    
    qint64 parentId;
    
    qint64 resourceId;
    
    QString remoteId;
    
    QString remoteRevision;
    
    QString name;
    
    QString cachePolicyLocalParts;
    
    QString queryString;
    
    QString queryLanguage;
    
    int cachePolicyCheckInterval;
    
    int cachePolicyCacheTimeout;
    
    bool subscribed : 1;
    
    bool cachePolicyInherit : 1;
    
    bool cachePolicySyncOnDemand : 1;
    
    bool remoteId_changed : 1;
    
    bool remoteRevision_changed : 1;
    
    bool name_changed : 1;
    
    bool parentId_changed : 1;
    
    bool resourceId_changed : 1;
    
    bool subscribed_changed : 1;
    
    bool cachePolicyInherit_changed : 1;
    
    bool cachePolicyCheckInterval_changed : 1;
    
    bool cachePolicyCacheTimeout_changed : 1;
    
    bool cachePolicySyncOnDemand_changed : 1;
    
    bool cachePolicyLocalParts_changed : 1;
    
    bool queryString_changed : 1;
    
    bool queryLanguage_changed : 1;
    

    static void addToCache( const Collection & entry );

    // cache
    static bool cacheEnabled;
    static QMutex cacheMutex;
    
    static QHash<qint64, Collection > idCache;
    
    static QHash<QString, Collection > nameCache;
    
};


// static members
bool Collection::Private::cacheEnabled = false;
QMutex Collection::Private::cacheMutex;

QHash<qint64, Collection > Collection::Private::idCache;

QHash<QString, Collection > Collection::Private::nameCache;



void Collection::Private::addToCache( const Collection & entry )
{
  Q_ASSERT( cacheEnabled );
  Q_UNUSED( entry ); 
  cacheMutex.lock();
  
  idCache.insert( entry.id(), entry );
  
  nameCache.insert( entry.name(), entry );
  
  cacheMutex.unlock();
}


// constructor
Collection::Collection() : Entity(),
  d( new Private )
{
}

Collection::Collection(
  const QString &remoteId, const QString &remoteRevision, const QString &name, qint64 parentId, qint64 resourceId, bool subscribed, bool cachePolicyInherit, int cachePolicyCheckInterval, int cachePolicyCacheTimeout, bool cachePolicySyncOnDemand, const QString &cachePolicyLocalParts, const QString &queryString, const QString &queryLanguage
) :
  Entity(),
  d( new Private )
{

  d->remoteId = remoteId;
  d->remoteId_changed = true;

  d->remoteRevision = remoteRevision;
  d->remoteRevision_changed = true;

  d->name = name;
  d->name_changed = true;

  d->parentId = parentId;
  d->parentId_changed = true;

  d->resourceId = resourceId;
  d->resourceId_changed = true;

  d->subscribed = subscribed;
  d->subscribed_changed = true;

  d->cachePolicyInherit = cachePolicyInherit;
  d->cachePolicyInherit_changed = true;

  d->cachePolicyCheckInterval = cachePolicyCheckInterval;
  d->cachePolicyCheckInterval_changed = true;

  d->cachePolicyCacheTimeout = cachePolicyCacheTimeout;
  d->cachePolicyCacheTimeout_changed = true;

  d->cachePolicySyncOnDemand = cachePolicySyncOnDemand;
  d->cachePolicySyncOnDemand_changed = true;

  d->cachePolicyLocalParts = cachePolicyLocalParts;
  d->cachePolicyLocalParts_changed = true;

  d->queryString = queryString;
  d->queryString_changed = true;

  d->queryLanguage = queryLanguage;
  d->queryLanguage_changed = true;

}

Collection::Collection(
  qint64 id, const QString &remoteId, const QString &remoteRevision, const QString &name, qint64 parentId, qint64 resourceId, bool subscribed, bool cachePolicyInherit, int cachePolicyCheckInterval, int cachePolicyCacheTimeout, bool cachePolicySyncOnDemand, const QString &cachePolicyLocalParts, const QString &queryString, const QString &queryLanguage
) :
  Entity( id ),
  d( new Private )
{

  d->remoteId = remoteId;
  d->remoteId_changed = true;

  d->remoteRevision = remoteRevision;
  d->remoteRevision_changed = true;

  d->name = name;
  d->name_changed = true;

  d->parentId = parentId;
  d->parentId_changed = true;

  d->resourceId = resourceId;
  d->resourceId_changed = true;

  d->subscribed = subscribed;
  d->subscribed_changed = true;

  d->cachePolicyInherit = cachePolicyInherit;
  d->cachePolicyInherit_changed = true;

  d->cachePolicyCheckInterval = cachePolicyCheckInterval;
  d->cachePolicyCheckInterval_changed = true;

  d->cachePolicyCacheTimeout = cachePolicyCacheTimeout;
  d->cachePolicyCacheTimeout_changed = true;

  d->cachePolicySyncOnDemand = cachePolicySyncOnDemand;
  d->cachePolicySyncOnDemand_changed = true;

  d->cachePolicyLocalParts = cachePolicyLocalParts;
  d->cachePolicyLocalParts_changed = true;

  d->queryString = queryString;
  d->queryString_changed = true;

  d->queryLanguage = queryLanguage;
  d->queryLanguage_changed = true;

}
Collection::Collection( const Collection & other )
  : Entity( other ), d( other.d )
{
}

// destructor
Collection::~Collection() {}

// assignment operator
Collection& Collection::operator=( const Collection & other )
{
  if ( this != &other ) {
    d = other.d;
    setId( other.id() );
  }
  return *this;
}

// comparisson operator
bool Collection::operator==( const Collection & other )
{
  return id() == other.id();
}

// accessor methods
QString Collection::remoteId() const
{
  return d->remoteId;
}

void Collection::
setRemoteId( const QString &remoteId )

{
  d->remoteId = remoteId;
  d->remoteId_changed = true;
}

QString Collection::remoteRevision() const
{
  return d->remoteRevision;
}

void Collection::
setRemoteRevision( const QString &remoteRevision )

{
  d->remoteRevision = remoteRevision;
  d->remoteRevision_changed = true;
}

QString Collection::name() const
{
  return d->name;
}

void Collection::
setName( const QString &name )

{
  d->name = name;
  d->name_changed = true;
}

qint64 Collection::parentId() const
{
  return d->parentId;
}

void Collection::
setParentId( qint64 parentId )

{
  d->parentId = parentId;
  d->parentId_changed = true;
}

qint64 Collection::resourceId() const
{
  return d->resourceId;
}

void Collection::
setResourceId( qint64 resourceId )

{
  d->resourceId = resourceId;
  d->resourceId_changed = true;
}

bool Collection::subscribed() const
{
  return d->subscribed;
}

void Collection::
setSubscribed( bool subscribed )

{
  d->subscribed = subscribed;
  d->subscribed_changed = true;
}

bool Collection::cachePolicyInherit() const
{
  return d->cachePolicyInherit;
}

void Collection::
setCachePolicyInherit( bool cachePolicyInherit )

{
  d->cachePolicyInherit = cachePolicyInherit;
  d->cachePolicyInherit_changed = true;
}

int Collection::cachePolicyCheckInterval() const
{
  return d->cachePolicyCheckInterval;
}

void Collection::
setCachePolicyCheckInterval( int cachePolicyCheckInterval )

{
  d->cachePolicyCheckInterval = cachePolicyCheckInterval;
  d->cachePolicyCheckInterval_changed = true;
}

int Collection::cachePolicyCacheTimeout() const
{
  return d->cachePolicyCacheTimeout;
}

void Collection::
setCachePolicyCacheTimeout( int cachePolicyCacheTimeout )

{
  d->cachePolicyCacheTimeout = cachePolicyCacheTimeout;
  d->cachePolicyCacheTimeout_changed = true;
}

bool Collection::cachePolicySyncOnDemand() const
{
  return d->cachePolicySyncOnDemand;
}

void Collection::
setCachePolicySyncOnDemand( bool cachePolicySyncOnDemand )

{
  d->cachePolicySyncOnDemand = cachePolicySyncOnDemand;
  d->cachePolicySyncOnDemand_changed = true;
}

QString Collection::cachePolicyLocalParts() const
{
  return d->cachePolicyLocalParts;
}

void Collection::
setCachePolicyLocalParts( const QString &cachePolicyLocalParts )

{
  d->cachePolicyLocalParts = cachePolicyLocalParts;
  d->cachePolicyLocalParts_changed = true;
}

QString Collection::queryString() const
{
  return d->queryString;
}

void Collection::
setQueryString( const QString &queryString )

{
  d->queryString = queryString;
  d->queryString_changed = true;
}

QString Collection::queryLanguage() const
{
  return d->queryLanguage;
}

void Collection::
setQueryLanguage( const QString &queryLanguage )

{
  d->queryLanguage = queryLanguage;
  d->queryLanguage_changed = true;
}



// SQL table information
QString Collection::tableName()
{
  return QLatin1String( "CollectionTable" );
}

QStringList Collection::columnNames()
{
  QStringList rv;
  
  rv.append( QLatin1String( "id" ) );
  
  rv.append( QLatin1String( "remoteId" ) );
  
  rv.append( QLatin1String( "remoteRevision" ) );
  
  rv.append( QLatin1String( "name" ) );
  
  rv.append( QLatin1String( "parentId" ) );
  
  rv.append( QLatin1String( "resourceId" ) );
  
  rv.append( QLatin1String( "subscribed" ) );
  
  rv.append( QLatin1String( "cachePolicyInherit" ) );
  
  rv.append( QLatin1String( "cachePolicyCheckInterval" ) );
  
  rv.append( QLatin1String( "cachePolicyCacheTimeout" ) );
  
  rv.append( QLatin1String( "cachePolicySyncOnDemand" ) );
  
  rv.append( QLatin1String( "cachePolicyLocalParts" ) );
  
  rv.append( QLatin1String( "queryString" ) );
  
  rv.append( QLatin1String( "queryLanguage" ) );
  
  return rv;
}

QStringList Collection::fullColumnNames()
{
  QStringList rv;
  
  rv.append( QLatin1String( "CollectionTable.id" ) );
  
  rv.append( QLatin1String( "CollectionTable.remoteId" ) );
  
  rv.append( QLatin1String( "CollectionTable.remoteRevision" ) );
  
  rv.append( QLatin1String( "CollectionTable.name" ) );
  
  rv.append( QLatin1String( "CollectionTable.parentId" ) );
  
  rv.append( QLatin1String( "CollectionTable.resourceId" ) );
  
  rv.append( QLatin1String( "CollectionTable.subscribed" ) );
  
  rv.append( QLatin1String( "CollectionTable.cachePolicyInherit" ) );
  
  rv.append( QLatin1String( "CollectionTable.cachePolicyCheckInterval" ) );
  
  rv.append( QLatin1String( "CollectionTable.cachePolicyCacheTimeout" ) );
  
  rv.append( QLatin1String( "CollectionTable.cachePolicySyncOnDemand" ) );
  
  rv.append( QLatin1String( "CollectionTable.cachePolicyLocalParts" ) );
  
  rv.append( QLatin1String( "CollectionTable.queryString" ) );
  
  rv.append( QLatin1String( "CollectionTable.queryLanguage" ) );
  
  return rv;
}


QString Collection::idColumn()
{
  return QLatin1String( "id" );
}

QString Collection::idFullColumnName()
{
  return tableName() + QLatin1String( ".id" );
}

QString Collection::remoteIdColumn()
{
  return QLatin1String( "remoteId" );
}

QString Collection::remoteIdFullColumnName()
{
  return tableName() + QLatin1String( ".remoteId" );
}

QString Collection::remoteRevisionColumn()
{
  return QLatin1String( "remoteRevision" );
}

QString Collection::remoteRevisionFullColumnName()
{
  return tableName() + QLatin1String( ".remoteRevision" );
}

QString Collection::nameColumn()
{
  return QLatin1String( "name" );
}

QString Collection::nameFullColumnName()
{
  return tableName() + QLatin1String( ".name" );
}

QString Collection::parentIdColumn()
{
  return QLatin1String( "parentId" );
}

QString Collection::parentIdFullColumnName()
{
  return tableName() + QLatin1String( ".parentId" );
}

QString Collection::resourceIdColumn()
{
  return QLatin1String( "resourceId" );
}

QString Collection::resourceIdFullColumnName()
{
  return tableName() + QLatin1String( ".resourceId" );
}

QString Collection::subscribedColumn()
{
  return QLatin1String( "subscribed" );
}

QString Collection::subscribedFullColumnName()
{
  return tableName() + QLatin1String( ".subscribed" );
}

QString Collection::cachePolicyInheritColumn()
{
  return QLatin1String( "cachePolicyInherit" );
}

QString Collection::cachePolicyInheritFullColumnName()
{
  return tableName() + QLatin1String( ".cachePolicyInherit" );
}

QString Collection::cachePolicyCheckIntervalColumn()
{
  return QLatin1String( "cachePolicyCheckInterval" );
}

QString Collection::cachePolicyCheckIntervalFullColumnName()
{
  return tableName() + QLatin1String( ".cachePolicyCheckInterval" );
}

QString Collection::cachePolicyCacheTimeoutColumn()
{
  return QLatin1String( "cachePolicyCacheTimeout" );
}

QString Collection::cachePolicyCacheTimeoutFullColumnName()
{
  return tableName() + QLatin1String( ".cachePolicyCacheTimeout" );
}

QString Collection::cachePolicySyncOnDemandColumn()
{
  return QLatin1String( "cachePolicySyncOnDemand" );
}

QString Collection::cachePolicySyncOnDemandFullColumnName()
{
  return tableName() + QLatin1String( ".cachePolicySyncOnDemand" );
}

QString Collection::cachePolicyLocalPartsColumn()
{
  return QLatin1String( "cachePolicyLocalParts" );
}

QString Collection::cachePolicyLocalPartsFullColumnName()
{
  return tableName() + QLatin1String( ".cachePolicyLocalParts" );
}

QString Collection::queryStringColumn()
{
  return QLatin1String( "queryString" );
}

QString Collection::queryStringFullColumnName()
{
  return tableName() + QLatin1String( ".queryString" );
}

QString Collection::queryLanguageColumn()
{
  return QLatin1String( "queryLanguage" );
}

QString Collection::queryLanguageFullColumnName()
{
  return tableName() + QLatin1String( ".queryLanguage" );
}



// count records
int Collection::count( const QString &column, const QVariant &value )
{
  return Entity::count<Collection>( column, value );
}

// check existence

bool Collection::exists( qint64 id )
{
  if ( Private::cacheEnabled ) {
    Private::cacheMutex.lock();
    if ( Private::idCache.contains( id ) ) {
      Private::cacheMutex.unlock();
      return true;
    }
    Private::cacheMutex.unlock();
  }
  return count( idColumn(), id ) > 0;
}

bool Collection::exists( const QString &name )
{
  if ( Private::cacheEnabled ) {
    Private::cacheMutex.lock();
    if ( Private::nameCache.contains( name ) ) {
      Private::cacheMutex.unlock();
      return true;
    }
    Private::cacheMutex.unlock();
  }
  return count( nameColumn(), name ) > 0;
}



// result extraction
QVector< Collection > Collection::extractResult( QSqlQuery & query )
{
  QVector<Collection> rv;
  while ( query.next() ) {
    rv.append( Collection(
      
        (query.isNull(0)) ?
          qint64() :
          
          query.value( 0 ).value<qint64>()
            ,
        (query.isNull(1)) ?
          QString() :
          
          Utils::variantToString( query.value( 1 ) )
            ,
        (query.isNull(2)) ?
          QString() :
          
          Utils::variantToString( query.value( 2 ) )
            ,
        (query.isNull(3)) ?
          QString() :
          
          Utils::variantToString( query.value( 3 ) )
            ,
        (query.isNull(4)) ?
          qint64() :
          
          query.value( 4 ).value<qint64>()
            ,
        (query.isNull(5)) ?
          qint64() :
          
          query.value( 5 ).value<qint64>()
            ,
        (query.isNull(6)) ?
          bool() :
          
          query.value( 6 ).value<bool>()
            ,
        (query.isNull(7)) ?
          bool() :
          
          query.value( 7 ).value<bool>()
            ,
        (query.isNull(8)) ?
          int() :
          
          query.value( 8 ).value<int>()
            ,
        (query.isNull(9)) ?
          int() :
          
          query.value( 9 ).value<int>()
            ,
        (query.isNull(10)) ?
          bool() :
          
          query.value( 10 ).value<bool>()
            ,
        (query.isNull(11)) ?
          QString() :
          
          Utils::variantToString( query.value( 11 ) )
            ,
        (query.isNull(12)) ?
          QString() :
          
          Utils::variantToString( query.value( 12 ) )
            ,
        (query.isNull(13)) ?
          QString() :
          
          Utils::variantToString( query.value( 13 ) )
            
    ) );
  }
  return rv;
}

// data retrieval
Collection Collection::retrieveById( qint64 id )
{
  
  if ( Private::cacheEnabled ) {
    Private::cacheMutex.lock();
    if ( Private::idCache.contains( id ) ) {
      Private::cacheMutex.unlock();
      return Private::idCache.value( id );
    }
    Private::cacheMutex.unlock();
  }
  
  QSqlDatabase db = DataStore::self()->database();
  if ( !db.isOpen() )
    return Collection();

  QSqlQuery query( db );
  QString statement = QLatin1String( "SELECT id, remoteId, remoteRevision, name, parentId, resourceId, subscribed, cachePolicyInherit, cachePolicyCheckInterval, cachePolicyCacheTimeout, cachePolicySyncOnDemand, cachePolicyLocalParts, queryString, queryLanguage FROM " );
  statement.append( tableName() );
  statement.append( QLatin1String(" WHERE id = :key") );
  query.prepare( statement );
  query.bindValue( QLatin1String(":key"), id );
  if ( !query.exec() ) {
    qDebug() << "Error during selection of record with id"
      << id << "from table" << tableName()
      << query.lastError().text();
    return Collection();
  }
  if ( !query.next() ) {
    return Collection();
  }

  Collection rv(
  
    (query.isNull(0)) ?
      qint64() :
      
      query.value( 0 ).value<qint64>()
        ,
    (query.isNull(1)) ?
      QString() :
      
      Utils::variantToString( query.value( 1 ) )
        ,
    (query.isNull(2)) ?
      QString() :
      
      Utils::variantToString( query.value( 2 ) )
        ,
    (query.isNull(3)) ?
      QString() :
      
      Utils::variantToString( query.value( 3 ) )
        ,
    (query.isNull(4)) ?
      qint64() :
      
      query.value( 4 ).value<qint64>()
        ,
    (query.isNull(5)) ?
      qint64() :
      
      query.value( 5 ).value<qint64>()
        ,
    (query.isNull(6)) ?
      bool() :
      
      query.value( 6 ).value<bool>()
        ,
    (query.isNull(7)) ?
      bool() :
      
      query.value( 7 ).value<bool>()
        ,
    (query.isNull(8)) ?
      int() :
      
      query.value( 8 ).value<int>()
        ,
    (query.isNull(9)) ?
      int() :
      
      query.value( 9 ).value<int>()
        ,
    (query.isNull(10)) ?
      bool() :
      
      query.value( 10 ).value<bool>()
        ,
    (query.isNull(11)) ?
      QString() :
      
      Utils::variantToString( query.value( 11 ) )
        ,
    (query.isNull(12)) ?
      QString() :
      
      Utils::variantToString( query.value( 12 ) )
        ,
    (query.isNull(13)) ?
      QString() :
      
      Utils::variantToString( query.value( 13 ) )
        
  );
  if ( Private::cacheEnabled ) {
    Private::addToCache( rv );
  }
  return rv;

}

Collection Collection::retrieveByName( const QString &name )
{
  
  if ( Private::cacheEnabled ) {
    Private::cacheMutex.lock();
    if ( Private::nameCache.contains( name ) ) {
      Private::cacheMutex.unlock();
      return Private::nameCache.value( name );
    }
    Private::cacheMutex.unlock();
  }
  
  QSqlDatabase db = DataStore::self()->database();
  if ( !db.isOpen() )
    return Collection();

  QSqlQuery query( db );
  QString statement = QLatin1String( "SELECT id, remoteId, remoteRevision, name, parentId, resourceId, subscribed, cachePolicyInherit, cachePolicyCheckInterval, cachePolicyCacheTimeout, cachePolicySyncOnDemand, cachePolicyLocalParts, queryString, queryLanguage FROM " );
  statement.append( tableName() );
  statement.append( QLatin1String(" WHERE name = :key") );
  query.prepare( statement );
  query.bindValue( QLatin1String(":key"), name );
  if ( !query.exec() ) {
    qDebug() << "Error during selection of record with name"
      << name << "from table" << tableName()
      << query.lastError().text();
    return Collection();
  }
  if ( !query.next() ) {
    return Collection();
  }

  Collection rv(
  
    (query.isNull(0)) ?
      qint64() :
      
      query.value( 0 ).value<qint64>()
        ,
    (query.isNull(1)) ?
      QString() :
      
      Utils::variantToString( query.value( 1 ) )
        ,
    (query.isNull(2)) ?
      QString() :
      
      Utils::variantToString( query.value( 2 ) )
        ,
    (query.isNull(3)) ?
      QString() :
      
      Utils::variantToString( query.value( 3 ) )
        ,
    (query.isNull(4)) ?
      qint64() :
      
      query.value( 4 ).value<qint64>()
        ,
    (query.isNull(5)) ?
      qint64() :
      
      query.value( 5 ).value<qint64>()
        ,
    (query.isNull(6)) ?
      bool() :
      
      query.value( 6 ).value<bool>()
        ,
    (query.isNull(7)) ?
      bool() :
      
      query.value( 7 ).value<bool>()
        ,
    (query.isNull(8)) ?
      int() :
      
      query.value( 8 ).value<int>()
        ,
    (query.isNull(9)) ?
      int() :
      
      query.value( 9 ).value<int>()
        ,
    (query.isNull(10)) ?
      bool() :
      
      query.value( 10 ).value<bool>()
        ,
    (query.isNull(11)) ?
      QString() :
      
      Utils::variantToString( query.value( 11 ) )
        ,
    (query.isNull(12)) ?
      QString() :
      
      Utils::variantToString( query.value( 12 ) )
        ,
    (query.isNull(13)) ?
      QString() :
      
      Utils::variantToString( query.value( 13 ) )
        
  );
  if ( Private::cacheEnabled ) {
    Private::addToCache( rv );
  }
  return rv;

}


QVector<Collection> Collection::retrieveAll()
{
  QSqlDatabase db = DataStore::self()->database();
  if ( !db.isOpen() )
    return QVector<Collection>();

  QSqlQuery query( db );
  QString statement = QLatin1String( "SELECT id, remoteId, remoteRevision, name, parentId, resourceId, subscribed, cachePolicyInherit, cachePolicyCheckInterval, cachePolicyCacheTimeout, cachePolicySyncOnDemand, cachePolicyLocalParts, queryString, queryLanguage FROM " );
  statement.append( tableName() );
  query.prepare( statement );
  if ( !query.exec() ) {
    qDebug() << "Error during selection of all records from table" << tableName()
      << query.lastError().text();
    return QVector<Collection>();
  }
  return extractResult( query );
}

QVector<Collection> Collection::retrieveFiltered( const QString &key, const QVariant &value )
{
  QSqlDatabase db = DataStore::self()->database();
  if ( !db.isOpen() )
    return QVector<Collection>();

  SelectQueryBuilder<Collection> qb;
  if ( value.isNull() )
    qb.addValueCondition( key, Query::Is, QVariant() );
  else
    qb.addValueCondition( key, Query::Equals, value );
  if ( !qb.exec() ) {
    qDebug() << "Error during selection of records from table" << tableName()
      << "filtered by" << key << "=" << value
      << qb.query().lastError().text();
    return QVector<Collection>();
  }
  return qb.result();
}

// data retrieval for referenced tables
Collection Collection::parent() const
{
  return Collection::retrieveById( parentId() );

}
Resource Collection::resource() const
{
  return Resource::retrieveById( resourceId() );

}


// data retrieval for inverse referenced tables

QVector<Collection> Collection::children() const
{
  return Collection::retrieveFiltered( Collection::parentIdColumn(), id() );
}

QVector<PimItem> Collection::items() const
{
  return PimItem::retrieveFiltered( PimItem::collectionIdColumn(), id() );
}

QVector<CollectionAttribute> Collection::attributes() const
{
  return CollectionAttribute::retrieveFiltered( CollectionAttribute::collectionIdColumn(), id() );
}


// data retrieval for n:m relations
QVector<MimeType> Collection::mimeTypes() const
{
  QSqlDatabase db = DataStore::self()->database();
  if ( !db.isOpen() )
    return QVector<MimeType>();

  QSqlQuery query( db );
  QString statement = QLatin1String( "SELECT " );
  
    statement.append( QLatin1String("MimeTypeTable.id" ) );
    
    statement.append( QLatin1String(", ") );
    
    statement.append( QLatin1String("MimeTypeTable.name" ) );
    
  statement.append( QLatin1String(" FROM MimeTypeTable, CollectionMimeTypeRelation") );
  statement.append( QLatin1String(" WHERE CollectionMimeTypeRelation.Collection_id = :key") );
  statement.append( QLatin1String(" AND CollectionMimeTypeRelation.MimeType_id = MimeTypeTable.id") );

  query.prepare( statement );
  query.bindValue( QLatin1String(":key"), id() );
  if ( !query.exec() ) {
    qDebug() << "Error during selection of records from table CollectionMimeTypeRelation"
      << query.lastError().text();
    return QVector<MimeType>();
  }

  return MimeType::extractResult( query );
}

// manipulate n:m relations
bool Collection::relatesToMimeType( const MimeType & value ) const
{
  return Entity::relatesTo<CollectionMimeTypeRelation>( id(), value.id() );
}

bool Collection::relatesToMimeType( qint64 leftId, qint64 rightId )
{
  return Entity::relatesTo<CollectionMimeTypeRelation>( leftId, rightId );
}

bool Collection::addMimeType( const MimeType & value ) const
{
  return Entity::addToRelation<CollectionMimeTypeRelation>( id(), value.id() );
}

bool Collection::addMimeType( qint64 leftId, qint64 rightId )
{
  return Entity::addToRelation<CollectionMimeTypeRelation>( leftId, rightId );
}

bool Collection::removeMimeType( const MimeType & value ) const
{
  return Entity::removeFromRelation<CollectionMimeTypeRelation>( id(), value.id() );
}

bool Collection::removeMimeType( qint64 leftId, qint64 rightId )
{
  return Entity::removeFromRelation<CollectionMimeTypeRelation>( leftId, rightId );
}

bool Collection::clearMimeTypes() const
{
  return Entity::clearRelation<CollectionMimeTypeRelation>( id() );
}

bool Collection::clearMimeTypes( qint64 id )
{
  return Entity::clearRelation<CollectionMimeTypeRelation>( id );
}



// data retrieval for n:m relations
QVector<PimItem> Collection::pimItems() const
{
  QSqlDatabase db = DataStore::self()->database();
  if ( !db.isOpen() )
    return QVector<PimItem>();

  QSqlQuery query( db );
  QString statement = QLatin1String( "SELECT " );
  
    statement.append( QLatin1String("PimItemTable.id" ) );
    
    statement.append( QLatin1String(", ") );
    
    statement.append( QLatin1String("PimItemTable.rev" ) );
    
    statement.append( QLatin1String(", ") );
    
    statement.append( QLatin1String("PimItemTable.remoteId" ) );
    
    statement.append( QLatin1String(", ") );
    
    statement.append( QLatin1String("PimItemTable.remoteRevision" ) );
    
    statement.append( QLatin1String(", ") );
    
    statement.append( QLatin1String("PimItemTable.collectionId" ) );
    
    statement.append( QLatin1String(", ") );
    
    statement.append( QLatin1String("PimItemTable.mimeTypeId" ) );
    
    statement.append( QLatin1String(", ") );
    
    statement.append( QLatin1String("PimItemTable.datetime" ) );
    
    statement.append( QLatin1String(", ") );
    
    statement.append( QLatin1String("PimItemTable.atime" ) );
    
    statement.append( QLatin1String(", ") );
    
    statement.append( QLatin1String("PimItemTable.dirty" ) );
    
    statement.append( QLatin1String(", ") );
    
    statement.append( QLatin1String("PimItemTable.size" ) );
    
  statement.append( QLatin1String(" FROM PimItemTable, CollectionPimItemRelation") );
  statement.append( QLatin1String(" WHERE CollectionPimItemRelation.Collection_id = :key") );
  statement.append( QLatin1String(" AND CollectionPimItemRelation.PimItem_id = PimItemTable.id") );

  query.prepare( statement );
  query.bindValue( QLatin1String(":key"), id() );
  if ( !query.exec() ) {
    qDebug() << "Error during selection of records from table CollectionPimItemRelation"
      << query.lastError().text();
    return QVector<PimItem>();
  }

  return PimItem::extractResult( query );
}

// manipulate n:m relations
bool Collection::relatesToPimItem( const PimItem & value ) const
{
  return Entity::relatesTo<CollectionPimItemRelation>( id(), value.id() );
}

bool Collection::relatesToPimItem( qint64 leftId, qint64 rightId )
{
  return Entity::relatesTo<CollectionPimItemRelation>( leftId, rightId );
}

bool Collection::addPimItem( const PimItem & value ) const
{
  return Entity::addToRelation<CollectionPimItemRelation>( id(), value.id() );
}

bool Collection::addPimItem( qint64 leftId, qint64 rightId )
{
  return Entity::addToRelation<CollectionPimItemRelation>( leftId, rightId );
}

bool Collection::removePimItem( const PimItem & value ) const
{
  return Entity::removeFromRelation<CollectionPimItemRelation>( id(), value.id() );
}

bool Collection::removePimItem( qint64 leftId, qint64 rightId )
{
  return Entity::removeFromRelation<CollectionPimItemRelation>( leftId, rightId );
}

bool Collection::clearPimItems() const
{
  return Entity::clearRelation<CollectionPimItemRelation>( id() );
}

bool Collection::clearPimItems( qint64 id )
{
  return Entity::clearRelation<CollectionPimItemRelation>( id );
}



// debug stream operator
QDebug & operator<<( QDebug& d, const Collection& entity )
{
  d << "[Collection: "
  
    << "id = " << entity.id()
    << ", "
    << "remoteId = " << entity.remoteId()
    << ", "
    << "remoteRevision = " << entity.remoteRevision()
    << ", "
    << "name = " << entity.name()
    << ", "
    << "parentId = " << entity.parentId()
    << ", "
    << "resourceId = " << entity.resourceId()
    << ", "
    << "subscribed = " << entity.subscribed()
    << ", "
    << "cachePolicyInherit = " << entity.cachePolicyInherit()
    << ", "
    << "cachePolicyCheckInterval = " << entity.cachePolicyCheckInterval()
    << ", "
    << "cachePolicyCacheTimeout = " << entity.cachePolicyCacheTimeout()
    << ", "
    << "cachePolicySyncOnDemand = " << entity.cachePolicySyncOnDemand()
    << ", "
    << "cachePolicyLocalParts = " << entity.cachePolicyLocalParts()
    << ", "
    << "queryString = " << entity.queryString()
    << ", "
    << "queryLanguage = " << entity.queryLanguage()
    
    << "]";
  return d;
}

// inserting new data
bool Collection::insert( qint64* insertId )
{
  QSqlDatabase db = DataStore::self()->database();
  if ( !db.isOpen() )
    return false;

  QueryBuilder qb( tableName(), QueryBuilder::Insert );
  
    if ( d->remoteId_changed )
      qb.setColumnValue( remoteIdColumn(), this->remoteId() );
    
    if ( d->remoteRevision_changed )
      qb.setColumnValue( remoteRevisionColumn(), this->remoteRevision() );
    
    if ( d->name_changed )
      qb.setColumnValue( nameColumn(), this->name() );
    
    if ( d->parentId_changed  && d->parentId > 0 )
      qb.setColumnValue( parentIdColumn(), this->parentId() );
    
    if ( d->resourceId_changed  && d->resourceId > 0 )
      qb.setColumnValue( resourceIdColumn(), this->resourceId() );
    
    if ( d->subscribed_changed )
      qb.setColumnValue( subscribedColumn(), this->subscribed() );
    
    if ( d->cachePolicyInherit_changed )
      qb.setColumnValue( cachePolicyInheritColumn(), this->cachePolicyInherit() );
    
    if ( d->cachePolicyCheckInterval_changed )
      qb.setColumnValue( cachePolicyCheckIntervalColumn(), this->cachePolicyCheckInterval() );
    
    if ( d->cachePolicyCacheTimeout_changed )
      qb.setColumnValue( cachePolicyCacheTimeoutColumn(), this->cachePolicyCacheTimeout() );
    
    if ( d->cachePolicySyncOnDemand_changed )
      qb.setColumnValue( cachePolicySyncOnDemandColumn(), this->cachePolicySyncOnDemand() );
    
    if ( d->cachePolicyLocalParts_changed )
      qb.setColumnValue( cachePolicyLocalPartsColumn(), this->cachePolicyLocalParts() );
    
    if ( d->queryString_changed )
      qb.setColumnValue( queryStringColumn(), this->queryString() );
    
    if ( d->queryLanguage_changed )
      qb.setColumnValue( queryLanguageColumn(), this->queryLanguage() );
    

  if ( !qb.exec() ) {
    qDebug() << "Error during insertion into table" << tableName()
      << qb.query().lastError().text();
    return false;
  }

  setId( qb.insertId() );
  if ( insertId )
    *insertId = id();
  return true;
}

bool Collection::hasPendingChanges() const
{
  return false
  
    || d->remoteId_changed
  
    || d->remoteRevision_changed
  
    || d->name_changed
  
    || d->parentId_changed
  
    || d->resourceId_changed
  
    || d->subscribed_changed
  
    || d->cachePolicyInherit_changed
  
    || d->cachePolicyCheckInterval_changed
  
    || d->cachePolicyCacheTimeout_changed
  
    || d->cachePolicySyncOnDemand_changed
  
    || d->cachePolicyLocalParts_changed
  
    || d->queryString_changed
  
    || d->queryLanguage_changed
  ;
}

// update existing data
bool Collection::update()
{
  invalidateCache();
  QSqlDatabase db = DataStore::self()->database();
  if ( !db.isOpen() )
    return false;

  QString statement = QLatin1String( "UPDATE " );
  statement += tableName();
  statement += QLatin1String( " SET " );

  QStringList cols;
  
    if ( d->remoteId_changed )
      cols.append( remoteIdColumn() + QLatin1String( " = :remoteId" ) );;
  
    if ( d->remoteRevision_changed )
      cols.append( remoteRevisionColumn() + QLatin1String( " = :remoteRevision" ) );;
  
    if ( d->name_changed )
      cols.append( nameColumn() + QLatin1String( " = :name" ) );;
  
    if ( d->parentId_changed )
      cols.append( parentIdColumn() + QLatin1String( " = :parentId" ) );;
  
    if ( d->resourceId_changed )
      cols.append( resourceIdColumn() + QLatin1String( " = :resourceId" ) );;
  
    if ( d->subscribed_changed )
      cols.append( subscribedColumn() + QLatin1String( " = :subscribed" ) );;
  
    if ( d->cachePolicyInherit_changed )
      cols.append( cachePolicyInheritColumn() + QLatin1String( " = :cachePolicyInherit" ) );;
  
    if ( d->cachePolicyCheckInterval_changed )
      cols.append( cachePolicyCheckIntervalColumn() + QLatin1String( " = :cachePolicyCheckInterval" ) );;
  
    if ( d->cachePolicyCacheTimeout_changed )
      cols.append( cachePolicyCacheTimeoutColumn() + QLatin1String( " = :cachePolicyCacheTimeout" ) );;
  
    if ( d->cachePolicySyncOnDemand_changed )
      cols.append( cachePolicySyncOnDemandColumn() + QLatin1String( " = :cachePolicySyncOnDemand" ) );;
  
    if ( d->cachePolicyLocalParts_changed )
      cols.append( cachePolicyLocalPartsColumn() + QLatin1String( " = :cachePolicyLocalParts" ) );;
  
    if ( d->queryString_changed )
      cols.append( queryStringColumn() + QLatin1String( " = :queryString" ) );;
  
    if ( d->queryLanguage_changed )
      cols.append( queryLanguageColumn() + QLatin1String( " = :queryLanguage" ) );;
  
  statement += cols.join( QLatin1String( ", " ) );
  
  statement += QLatin1String( " WHERE id = :id" );
  

  QSqlQuery query( db );
  query.prepare( statement );
  
    if ( d->remoteId_changed ) {
      
        query.bindValue( QLatin1String(":remoteId"), this->remoteId() );
    }
  
    if ( d->remoteRevision_changed ) {
      
        query.bindValue( QLatin1String(":remoteRevision"), this->remoteRevision() );
    }
  
    if ( d->name_changed ) {
      
        query.bindValue( QLatin1String(":name"), this->name() );
    }
  
    if ( d->parentId_changed ) {
      
      if ( d->parentId <= 0 )
        query.bindValue( QLatin1String(":parentId"), QVariant() );
      else
      
        query.bindValue( QLatin1String(":parentId"), this->parentId() );
    }
  
    if ( d->resourceId_changed ) {
      
      if ( d->resourceId <= 0 )
        query.bindValue( QLatin1String(":resourceId"), QVariant() );
      else
      
        query.bindValue( QLatin1String(":resourceId"), this->resourceId() );
    }
  
    if ( d->subscribed_changed ) {
      
        query.bindValue( QLatin1String(":subscribed"), this->subscribed() );
    }
  
    if ( d->cachePolicyInherit_changed ) {
      
        query.bindValue( QLatin1String(":cachePolicyInherit"), this->cachePolicyInherit() );
    }
  
    if ( d->cachePolicyCheckInterval_changed ) {
      
        query.bindValue( QLatin1String(":cachePolicyCheckInterval"), this->cachePolicyCheckInterval() );
    }
  
    if ( d->cachePolicyCacheTimeout_changed ) {
      
        query.bindValue( QLatin1String(":cachePolicyCacheTimeout"), this->cachePolicyCacheTimeout() );
    }
  
    if ( d->cachePolicySyncOnDemand_changed ) {
      
        query.bindValue( QLatin1String(":cachePolicySyncOnDemand"), this->cachePolicySyncOnDemand() );
    }
  
    if ( d->cachePolicyLocalParts_changed ) {
      
        query.bindValue( QLatin1String(":cachePolicyLocalParts"), this->cachePolicyLocalParts() );
    }
  
    if ( d->queryString_changed ) {
      
        query.bindValue( QLatin1String(":queryString"), this->queryString() );
    }
  
    if ( d->queryLanguage_changed ) {
      
        query.bindValue( QLatin1String(":queryLanguage"), this->queryLanguage() );
    }
  
  query.bindValue( QLatin1String(":id"), id() );
  
  if ( !query.exec() ) {
    qDebug() << "Error during updating record with id" << id()
             << " in table" << tableName() << query.lastError().text();
    return false;
  }
  return true;
}

// delete records
bool Collection::remove( const QString &column, const QVariant &value )
{
  invalidateCompleteCache();
  return Entity::remove<Collection>( column, value );
}


bool Collection::remove()
{
  invalidateCache();
  return Entity::remove<Collection>( idColumn(), id() );
}

bool Collection::remove( qint64 id )
{
  return remove( idColumn(), id );
}


// cache stuff
void Collection::invalidateCache() const
{
  if ( Private::cacheEnabled ) {
    Private::cacheMutex.lock();
    
    Private::idCache.remove( id() );
    
    Private::nameCache.remove( name() );
    
    Private::cacheMutex.unlock();
  }
}

void Collection::invalidateCompleteCache()
{
  if ( Private::cacheEnabled ) {
    Private::cacheMutex.lock();
    
    Private::idCache.clear();
    
    Private::nameCache.clear();
    
    Private::cacheMutex.unlock();
  }
}

void Collection::enableCache( bool enable )
{
  Private::cacheEnabled = enable;
}



// private class
class MimeType::Private : public QSharedData
{
  public:
    Private() : QSharedData()
    
      , name()
    
      , name_changed( false )
    
    {}

    
    QString name;
    
    bool name_changed : 1;
    

    static void addToCache( const MimeType & entry );

    // cache
    static bool cacheEnabled;
    static QMutex cacheMutex;
    
    static QHash<qint64, MimeType > idCache;
    
    static QHash<QString, MimeType > nameCache;
    
};


// static members
bool MimeType::Private::cacheEnabled = false;
QMutex MimeType::Private::cacheMutex;

QHash<qint64, MimeType > MimeType::Private::idCache;

QHash<QString, MimeType > MimeType::Private::nameCache;



void MimeType::Private::addToCache( const MimeType & entry )
{
  Q_ASSERT( cacheEnabled );
  Q_UNUSED( entry ); 
  cacheMutex.lock();
  
  idCache.insert( entry.id(), entry );
  
  nameCache.insert( entry.name(), entry );
  
  cacheMutex.unlock();
}


// constructor
MimeType::MimeType() : Entity(),
  d( new Private )
{
}

MimeType::MimeType(
  const QString &name
) :
  Entity(),
  d( new Private )
{

  d->name = name;
  d->name_changed = true;

}

MimeType::MimeType(
  qint64 id, const QString &name
) :
  Entity( id ),
  d( new Private )
{

  d->name = name;
  d->name_changed = true;

}
MimeType::MimeType( const MimeType & other )
  : Entity( other ), d( other.d )
{
}

// destructor
MimeType::~MimeType() {}

// assignment operator
MimeType& MimeType::operator=( const MimeType & other )
{
  if ( this != &other ) {
    d = other.d;
    setId( other.id() );
  }
  return *this;
}

// comparisson operator
bool MimeType::operator==( const MimeType & other )
{
  return id() == other.id();
}

// accessor methods
QString MimeType::name() const
{
  return d->name;
}

void MimeType::
setName( const QString &name )

{
  d->name = name;
  d->name_changed = true;
}



// SQL table information
QString MimeType::tableName()
{
  return QLatin1String( "MimeTypeTable" );
}

QStringList MimeType::columnNames()
{
  QStringList rv;
  
  rv.append( QLatin1String( "id" ) );
  
  rv.append( QLatin1String( "name" ) );
  
  return rv;
}

QStringList MimeType::fullColumnNames()
{
  QStringList rv;
  
  rv.append( QLatin1String( "MimeTypeTable.id" ) );
  
  rv.append( QLatin1String( "MimeTypeTable.name" ) );
  
  return rv;
}


QString MimeType::idColumn()
{
  return QLatin1String( "id" );
}

QString MimeType::idFullColumnName()
{
  return tableName() + QLatin1String( ".id" );
}

QString MimeType::nameColumn()
{
  return QLatin1String( "name" );
}

QString MimeType::nameFullColumnName()
{
  return tableName() + QLatin1String( ".name" );
}



// count records
int MimeType::count( const QString &column, const QVariant &value )
{
  return Entity::count<MimeType>( column, value );
}

// check existence

bool MimeType::exists( qint64 id )
{
  if ( Private::cacheEnabled ) {
    Private::cacheMutex.lock();
    if ( Private::idCache.contains( id ) ) {
      Private::cacheMutex.unlock();
      return true;
    }
    Private::cacheMutex.unlock();
  }
  return count( idColumn(), id ) > 0;
}

bool MimeType::exists( const QString &name )
{
  if ( Private::cacheEnabled ) {
    Private::cacheMutex.lock();
    if ( Private::nameCache.contains( name ) ) {
      Private::cacheMutex.unlock();
      return true;
    }
    Private::cacheMutex.unlock();
  }
  return count( nameColumn(), name ) > 0;
}



// result extraction
QVector< MimeType > MimeType::extractResult( QSqlQuery & query )
{
  QVector<MimeType> rv;
  while ( query.next() ) {
    rv.append( MimeType(
      
        (query.isNull(0)) ?
          qint64() :
          
          query.value( 0 ).value<qint64>()
            ,
        (query.isNull(1)) ?
          QString() :
          
          Utils::variantToString( query.value( 1 ) )
            
    ) );
  }
  return rv;
}

// data retrieval
MimeType MimeType::retrieveById( qint64 id )
{
  
  if ( Private::cacheEnabled ) {
    Private::cacheMutex.lock();
    if ( Private::idCache.contains( id ) ) {
      Private::cacheMutex.unlock();
      return Private::idCache.value( id );
    }
    Private::cacheMutex.unlock();
  }
  
  QSqlDatabase db = DataStore::self()->database();
  if ( !db.isOpen() )
    return MimeType();

  QSqlQuery query( db );
  QString statement = QLatin1String( "SELECT id, name FROM " );
  statement.append( tableName() );
  statement.append( QLatin1String(" WHERE id = :key") );
  query.prepare( statement );
  query.bindValue( QLatin1String(":key"), id );
  if ( !query.exec() ) {
    qDebug() << "Error during selection of record with id"
      << id << "from table" << tableName()
      << query.lastError().text();
    return MimeType();
  }
  if ( !query.next() ) {
    return MimeType();
  }

  MimeType rv(
  
    (query.isNull(0)) ?
      qint64() :
      
      query.value( 0 ).value<qint64>()
        ,
    (query.isNull(1)) ?
      QString() :
      
      Utils::variantToString( query.value( 1 ) )
        
  );
  if ( Private::cacheEnabled ) {
    Private::addToCache( rv );
  }
  return rv;

}

MimeType MimeType::retrieveByName( const QString &name )
{
  
  if ( Private::cacheEnabled ) {
    Private::cacheMutex.lock();
    if ( Private::nameCache.contains( name ) ) {
      Private::cacheMutex.unlock();
      return Private::nameCache.value( name );
    }
    Private::cacheMutex.unlock();
  }
  
  QSqlDatabase db = DataStore::self()->database();
  if ( !db.isOpen() )
    return MimeType();

  QSqlQuery query( db );
  QString statement = QLatin1String( "SELECT id, name FROM " );
  statement.append( tableName() );
  statement.append( QLatin1String(" WHERE name = :key") );
  query.prepare( statement );
  query.bindValue( QLatin1String(":key"), name );
  if ( !query.exec() ) {
    qDebug() << "Error during selection of record with name"
      << name << "from table" << tableName()
      << query.lastError().text();
    return MimeType();
  }
  if ( !query.next() ) {
    return MimeType();
  }

  MimeType rv(
  
    (query.isNull(0)) ?
      qint64() :
      
      query.value( 0 ).value<qint64>()
        ,
    (query.isNull(1)) ?
      QString() :
      
      Utils::variantToString( query.value( 1 ) )
        
  );
  if ( Private::cacheEnabled ) {
    Private::addToCache( rv );
  }
  return rv;

}


QVector<MimeType> MimeType::retrieveAll()
{
  QSqlDatabase db = DataStore::self()->database();
  if ( !db.isOpen() )
    return QVector<MimeType>();

  QSqlQuery query( db );
  QString statement = QLatin1String( "SELECT id, name FROM " );
  statement.append( tableName() );
  query.prepare( statement );
  if ( !query.exec() ) {
    qDebug() << "Error during selection of all records from table" << tableName()
      << query.lastError().text();
    return QVector<MimeType>();
  }
  return extractResult( query );
}

QVector<MimeType> MimeType::retrieveFiltered( const QString &key, const QVariant &value )
{
  QSqlDatabase db = DataStore::self()->database();
  if ( !db.isOpen() )
    return QVector<MimeType>();

  SelectQueryBuilder<MimeType> qb;
  if ( value.isNull() )
    qb.addValueCondition( key, Query::Is, QVariant() );
  else
    qb.addValueCondition( key, Query::Equals, value );
  if ( !qb.exec() ) {
    qDebug() << "Error during selection of records from table" << tableName()
      << "filtered by" << key << "=" << value
      << qb.query().lastError().text();
    return QVector<MimeType>();
  }
  return qb.result();
}

// data retrieval for referenced tables


// data retrieval for inverse referenced tables


// debug stream operator
QDebug & operator<<( QDebug& d, const MimeType& entity )
{
  d << "[MimeType: "
  
    << "id = " << entity.id()
    << ", "
    << "name = " << entity.name()
    
    << "]";
  return d;
}

// inserting new data
bool MimeType::insert( qint64* insertId )
{
  QSqlDatabase db = DataStore::self()->database();
  if ( !db.isOpen() )
    return false;

  QueryBuilder qb( tableName(), QueryBuilder::Insert );
  
    if ( d->name_changed )
      qb.setColumnValue( nameColumn(), this->name() );
    

  if ( !qb.exec() ) {
    qDebug() << "Error during insertion into table" << tableName()
      << qb.query().lastError().text();
    return false;
  }

  setId( qb.insertId() );
  if ( insertId )
    *insertId = id();
  return true;
}

bool MimeType::hasPendingChanges() const
{
  return false
  
    || d->name_changed
  ;
}

// update existing data
bool MimeType::update()
{
  invalidateCache();
  QSqlDatabase db = DataStore::self()->database();
  if ( !db.isOpen() )
    return false;

  QString statement = QLatin1String( "UPDATE " );
  statement += tableName();
  statement += QLatin1String( " SET " );

  QStringList cols;
  
    if ( d->name_changed )
      cols.append( nameColumn() + QLatin1String( " = :name" ) );;
  
  statement += cols.join( QLatin1String( ", " ) );
  
  statement += QLatin1String( " WHERE id = :id" );
  

  QSqlQuery query( db );
  query.prepare( statement );
  
    if ( d->name_changed ) {
      
        query.bindValue( QLatin1String(":name"), this->name() );
    }
  
  query.bindValue( QLatin1String(":id"), id() );
  
  if ( !query.exec() ) {
    qDebug() << "Error during updating record with id" << id()
             << " in table" << tableName() << query.lastError().text();
    return false;
  }
  return true;
}

// delete records
bool MimeType::remove( const QString &column, const QVariant &value )
{
  invalidateCompleteCache();
  return Entity::remove<MimeType>( column, value );
}


bool MimeType::remove()
{
  invalidateCache();
  return Entity::remove<MimeType>( idColumn(), id() );
}

bool MimeType::remove( qint64 id )
{
  return remove( idColumn(), id );
}


// cache stuff
void MimeType::invalidateCache() const
{
  if ( Private::cacheEnabled ) {
    Private::cacheMutex.lock();
    
    Private::idCache.remove( id() );
    
    Private::nameCache.remove( name() );
    
    Private::cacheMutex.unlock();
  }
}

void MimeType::invalidateCompleteCache()
{
  if ( Private::cacheEnabled ) {
    Private::cacheMutex.lock();
    
    Private::idCache.clear();
    
    Private::nameCache.clear();
    
    Private::cacheMutex.unlock();
  }
}

void MimeType::enableCache( bool enable )
{
  Private::cacheEnabled = enable;
}



// private class
class PimItem::Private : public QSharedData
{
  public:
    Private() : QSharedData()
    
      , collectionId( 0 )
    
      , mimeTypeId( 0 )
    
      , size( 0 )
    
#ifdef Q_OS_WINCE // on wince, QDateTime is two int's
    
      , datetime()
    
      , atime()
    
#endif
    
      , remoteId()
    
      , remoteRevision()
    
#ifndef Q_OS_WINCE // on non-wince, QDateTime is one int
    
      , datetime()
    
      , atime()
    
#endif
    
      , rev( 0 )
    
      , dirty( false )
    
      , rev_changed( false )
    
      , remoteId_changed( false )
    
      , remoteRevision_changed( false )
    
      , collectionId_changed( false )
    
      , mimeTypeId_changed( false )
    
      , datetime_changed( false )
    
      , atime_changed( false )
    
      , dirty_changed( false )
    
      , size_changed( false )
    
    {}

    
    qint64 collectionId;
    
    qint64 mimeTypeId;
    
    qint64 size;
    
#ifdef Q_OS_WINCE // on wince, QDateTime is two int's
    
    QDateTime datetime;
    
    QDateTime atime;
    
#endif
    
    QString remoteId;
    
    QString remoteRevision;
    
#ifndef Q_OS_WINCE // on non-wince, QDateTime is one int
    
    QDateTime datetime;
    
    QDateTime atime;
    
#endif
    
    int rev;
    
    bool dirty : 1;
    
    bool rev_changed : 1;
    
    bool remoteId_changed : 1;
    
    bool remoteRevision_changed : 1;
    
    bool collectionId_changed : 1;
    
    bool mimeTypeId_changed : 1;
    
    bool datetime_changed : 1;
    
    bool atime_changed : 1;
    
    bool dirty_changed : 1;
    
    bool size_changed : 1;
    

    static void addToCache( const PimItem & entry );

    // cache
    static bool cacheEnabled;
    static QMutex cacheMutex;
    
    static QHash<qint64, PimItem > idCache;
    
};


// static members
bool PimItem::Private::cacheEnabled = false;
QMutex PimItem::Private::cacheMutex;

QHash<qint64, PimItem > PimItem::Private::idCache;



void PimItem::Private::addToCache( const PimItem & entry )
{
  Q_ASSERT( cacheEnabled );
  Q_UNUSED( entry ); 
  cacheMutex.lock();
  
  idCache.insert( entry.id(), entry );
  
  cacheMutex.unlock();
}


// constructor
PimItem::PimItem() : Entity(),
  d( new Private )
{
}

PimItem::PimItem(
  int rev, const QString &remoteId, const QString &remoteRevision, qint64 collectionId, qint64 mimeTypeId, const QDateTime &datetime, const QDateTime &atime, bool dirty, qint64 size
) :
  Entity(),
  d( new Private )
{

  d->rev = rev;
  d->rev_changed = true;

  d->remoteId = remoteId;
  d->remoteId_changed = true;

  d->remoteRevision = remoteRevision;
  d->remoteRevision_changed = true;

  d->collectionId = collectionId;
  d->collectionId_changed = true;

  d->mimeTypeId = mimeTypeId;
  d->mimeTypeId_changed = true;

  d->datetime = datetime;
  d->datetime_changed = true;

  d->atime = atime;
  d->atime_changed = true;

  d->dirty = dirty;
  d->dirty_changed = true;

  d->size = size;
  d->size_changed = true;

}

PimItem::PimItem(
  qint64 id, int rev, const QString &remoteId, const QString &remoteRevision, qint64 collectionId, qint64 mimeTypeId, const QDateTime &datetime, const QDateTime &atime, bool dirty, qint64 size
) :
  Entity( id ),
  d( new Private )
{

  d->rev = rev;
  d->rev_changed = true;

  d->remoteId = remoteId;
  d->remoteId_changed = true;

  d->remoteRevision = remoteRevision;
  d->remoteRevision_changed = true;

  d->collectionId = collectionId;
  d->collectionId_changed = true;

  d->mimeTypeId = mimeTypeId;
  d->mimeTypeId_changed = true;

  d->datetime = datetime;
  d->datetime_changed = true;

  d->atime = atime;
  d->atime_changed = true;

  d->dirty = dirty;
  d->dirty_changed = true;

  d->size = size;
  d->size_changed = true;

}
PimItem::PimItem( const PimItem & other )
  : Entity( other ), d( other.d )
{
}

// destructor
PimItem::~PimItem() {}

// assignment operator
PimItem& PimItem::operator=( const PimItem & other )
{
  if ( this != &other ) {
    d = other.d;
    setId( other.id() );
  }
  return *this;
}

// comparisson operator
bool PimItem::operator==( const PimItem & other )
{
  return id() == other.id();
}

// accessor methods
int PimItem::rev() const
{
  return d->rev;
}

void PimItem::
setRev( int rev )

{
  d->rev = rev;
  d->rev_changed = true;
}

QString PimItem::remoteId() const
{
  return d->remoteId;
}

void PimItem::
setRemoteId( const QString &remoteId )

{
  d->remoteId = remoteId;
  d->remoteId_changed = true;
}

QString PimItem::remoteRevision() const
{
  return d->remoteRevision;
}

void PimItem::
setRemoteRevision( const QString &remoteRevision )

{
  d->remoteRevision = remoteRevision;
  d->remoteRevision_changed = true;
}

qint64 PimItem::collectionId() const
{
  return d->collectionId;
}

void PimItem::
setCollectionId( qint64 collectionId )

{
  d->collectionId = collectionId;
  d->collectionId_changed = true;
}

qint64 PimItem::mimeTypeId() const
{
  return d->mimeTypeId;
}

void PimItem::
setMimeTypeId( qint64 mimeTypeId )

{
  d->mimeTypeId = mimeTypeId;
  d->mimeTypeId_changed = true;
}

QDateTime PimItem::datetime() const
{
  return d->datetime;
}

void PimItem::
setDatetime( const QDateTime &datetime )

{
  d->datetime = datetime;
  d->datetime_changed = true;
}

QDateTime PimItem::atime() const
{
  return d->atime;
}

void PimItem::
setAtime( const QDateTime &atime )

{
  d->atime = atime;
  d->atime_changed = true;
}

bool PimItem::dirty() const
{
  return d->dirty;
}

void PimItem::
setDirty( bool dirty )

{
  d->dirty = dirty;
  d->dirty_changed = true;
}

qint64 PimItem::size() const
{
  return d->size;
}

void PimItem::
setSize( qint64 size )

{
  d->size = size;
  d->size_changed = true;
}



// SQL table information
QString PimItem::tableName()
{
  return QLatin1String( "PimItemTable" );
}

QStringList PimItem::columnNames()
{
  QStringList rv;
  
  rv.append( QLatin1String( "id" ) );
  
  rv.append( QLatin1String( "rev" ) );
  
  rv.append( QLatin1String( "remoteId" ) );
  
  rv.append( QLatin1String( "remoteRevision" ) );
  
  rv.append( QLatin1String( "collectionId" ) );
  
  rv.append( QLatin1String( "mimeTypeId" ) );
  
  rv.append( QLatin1String( "datetime" ) );
  
  rv.append( QLatin1String( "atime" ) );
  
  rv.append( QLatin1String( "dirty" ) );
  
  rv.append( QLatin1String( "size" ) );
  
  return rv;
}

QStringList PimItem::fullColumnNames()
{
  QStringList rv;
  
  rv.append( QLatin1String( "PimItemTable.id" ) );
  
  rv.append( QLatin1String( "PimItemTable.rev" ) );
  
  rv.append( QLatin1String( "PimItemTable.remoteId" ) );
  
  rv.append( QLatin1String( "PimItemTable.remoteRevision" ) );
  
  rv.append( QLatin1String( "PimItemTable.collectionId" ) );
  
  rv.append( QLatin1String( "PimItemTable.mimeTypeId" ) );
  
  rv.append( QLatin1String( "PimItemTable.datetime" ) );
  
  rv.append( QLatin1String( "PimItemTable.atime" ) );
  
  rv.append( QLatin1String( "PimItemTable.dirty" ) );
  
  rv.append( QLatin1String( "PimItemTable.size" ) );
  
  return rv;
}


QString PimItem::idColumn()
{
  return QLatin1String( "id" );
}

QString PimItem::idFullColumnName()
{
  return tableName() + QLatin1String( ".id" );
}

QString PimItem::revColumn()
{
  return QLatin1String( "rev" );
}

QString PimItem::revFullColumnName()
{
  return tableName() + QLatin1String( ".rev" );
}

QString PimItem::remoteIdColumn()
{
  return QLatin1String( "remoteId" );
}

QString PimItem::remoteIdFullColumnName()
{
  return tableName() + QLatin1String( ".remoteId" );
}

QString PimItem::remoteRevisionColumn()
{
  return QLatin1String( "remoteRevision" );
}

QString PimItem::remoteRevisionFullColumnName()
{
  return tableName() + QLatin1String( ".remoteRevision" );
}

QString PimItem::collectionIdColumn()
{
  return QLatin1String( "collectionId" );
}

QString PimItem::collectionIdFullColumnName()
{
  return tableName() + QLatin1String( ".collectionId" );
}

QString PimItem::mimeTypeIdColumn()
{
  return QLatin1String( "mimeTypeId" );
}

QString PimItem::mimeTypeIdFullColumnName()
{
  return tableName() + QLatin1String( ".mimeTypeId" );
}

QString PimItem::datetimeColumn()
{
  return QLatin1String( "datetime" );
}

QString PimItem::datetimeFullColumnName()
{
  return tableName() + QLatin1String( ".datetime" );
}

QString PimItem::atimeColumn()
{
  return QLatin1String( "atime" );
}

QString PimItem::atimeFullColumnName()
{
  return tableName() + QLatin1String( ".atime" );
}

QString PimItem::dirtyColumn()
{
  return QLatin1String( "dirty" );
}

QString PimItem::dirtyFullColumnName()
{
  return tableName() + QLatin1String( ".dirty" );
}

QString PimItem::sizeColumn()
{
  return QLatin1String( "size" );
}

QString PimItem::sizeFullColumnName()
{
  return tableName() + QLatin1String( ".size" );
}



// count records
int PimItem::count( const QString &column, const QVariant &value )
{
  return Entity::count<PimItem>( column, value );
}

// check existence

bool PimItem::exists( qint64 id )
{
  if ( Private::cacheEnabled ) {
    Private::cacheMutex.lock();
    if ( Private::idCache.contains( id ) ) {
      Private::cacheMutex.unlock();
      return true;
    }
    Private::cacheMutex.unlock();
  }
  return count( idColumn(), id ) > 0;
}



// result extraction
QVector< PimItem > PimItem::extractResult( QSqlQuery & query )
{
  QVector<PimItem> rv;
  while ( query.next() ) {
    rv.append( PimItem(
      
        (query.isNull(0)) ?
          qint64() :
          
          query.value( 0 ).value<qint64>()
            ,
        (query.isNull(1)) ?
          int() :
          
          query.value( 1 ).value<int>()
            ,
        (query.isNull(2)) ?
          QString() :
          
          Utils::variantToString( query.value( 2 ) )
            ,
        (query.isNull(3)) ?
          QString() :
          
          Utils::variantToString( query.value( 3 ) )
            ,
        (query.isNull(4)) ?
          qint64() :
          
          query.value( 4 ).value<qint64>()
            ,
        (query.isNull(5)) ?
          qint64() :
          
          query.value( 5 ).value<qint64>()
            ,
        (query.isNull(6)) ?
          QDateTime() :
          
          query.value( 6 ).value<QDateTime>()
            ,
        (query.isNull(7)) ?
          QDateTime() :
          
          query.value( 7 ).value<QDateTime>()
            ,
        (query.isNull(8)) ?
          bool() :
          
          query.value( 8 ).value<bool>()
            ,
        (query.isNull(9)) ?
          qint64() :
          
          query.value( 9 ).value<qint64>()
            
    ) );
  }
  return rv;
}

// data retrieval
PimItem PimItem::retrieveById( qint64 id )
{
  
  if ( Private::cacheEnabled ) {
    Private::cacheMutex.lock();
    if ( Private::idCache.contains( id ) ) {
      Private::cacheMutex.unlock();
      return Private::idCache.value( id );
    }
    Private::cacheMutex.unlock();
  }
  
  QSqlDatabase db = DataStore::self()->database();
  if ( !db.isOpen() )
    return PimItem();

  QSqlQuery query( db );
  QString statement = QLatin1String( "SELECT id, rev, remoteId, remoteRevision, collectionId, mimeTypeId, datetime, atime, dirty, size FROM " );
  statement.append( tableName() );
  statement.append( QLatin1String(" WHERE id = :key") );
  query.prepare( statement );
  query.bindValue( QLatin1String(":key"), id );
  if ( !query.exec() ) {
    qDebug() << "Error during selection of record with id"
      << id << "from table" << tableName()
      << query.lastError().text();
    return PimItem();
  }
  if ( !query.next() ) {
    return PimItem();
  }

  PimItem rv(
  
    (query.isNull(0)) ?
      qint64() :
      
      query.value( 0 ).value<qint64>()
        ,
    (query.isNull(1)) ?
      int() :
      
      query.value( 1 ).value<int>()
        ,
    (query.isNull(2)) ?
      QString() :
      
      Utils::variantToString( query.value( 2 ) )
        ,
    (query.isNull(3)) ?
      QString() :
      
      Utils::variantToString( query.value( 3 ) )
        ,
    (query.isNull(4)) ?
      qint64() :
      
      query.value( 4 ).value<qint64>()
        ,
    (query.isNull(5)) ?
      qint64() :
      
      query.value( 5 ).value<qint64>()
        ,
    (query.isNull(6)) ?
      QDateTime() :
      
      query.value( 6 ).value<QDateTime>()
        ,
    (query.isNull(7)) ?
      QDateTime() :
      
      query.value( 7 ).value<QDateTime>()
        ,
    (query.isNull(8)) ?
      bool() :
      
      query.value( 8 ).value<bool>()
        ,
    (query.isNull(9)) ?
      qint64() :
      
      query.value( 9 ).value<qint64>()
        
  );
  if ( Private::cacheEnabled ) {
    Private::addToCache( rv );
  }
  return rv;

}



QVector<PimItem> PimItem::retrieveAll()
{
  QSqlDatabase db = DataStore::self()->database();
  if ( !db.isOpen() )
    return QVector<PimItem>();

  QSqlQuery query( db );
  QString statement = QLatin1String( "SELECT id, rev, remoteId, remoteRevision, collectionId, mimeTypeId, datetime, atime, dirty, size FROM " );
  statement.append( tableName() );
  query.prepare( statement );
  if ( !query.exec() ) {
    qDebug() << "Error during selection of all records from table" << tableName()
      << query.lastError().text();
    return QVector<PimItem>();
  }
  return extractResult( query );
}

QVector<PimItem> PimItem::retrieveFiltered( const QString &key, const QVariant &value )
{
  QSqlDatabase db = DataStore::self()->database();
  if ( !db.isOpen() )
    return QVector<PimItem>();

  SelectQueryBuilder<PimItem> qb;
  if ( value.isNull() )
    qb.addValueCondition( key, Query::Is, QVariant() );
  else
    qb.addValueCondition( key, Query::Equals, value );
  if ( !qb.exec() ) {
    qDebug() << "Error during selection of records from table" << tableName()
      << "filtered by" << key << "=" << value
      << qb.query().lastError().text();
    return QVector<PimItem>();
  }
  return qb.result();
}

// data retrieval for referenced tables
Collection PimItem::collection() const
{
  return Collection::retrieveById( collectionId() );

}
MimeType PimItem::mimeType() const
{
  return MimeType::retrieveById( mimeTypeId() );

}


// data retrieval for inverse referenced tables

QVector<Part> PimItem::parts() const
{
  return Part::retrieveFiltered( Part::pimItemIdColumn(), id() );
}


// data retrieval for n:m relations
QVector<Flag> PimItem::flags() const
{
  QSqlDatabase db = DataStore::self()->database();
  if ( !db.isOpen() )
    return QVector<Flag>();

  QSqlQuery query( db );
  QString statement = QLatin1String( "SELECT " );
  
    statement.append( QLatin1String("FlagTable.id" ) );
    
    statement.append( QLatin1String(", ") );
    
    statement.append( QLatin1String("FlagTable.name" ) );
    
  statement.append( QLatin1String(" FROM FlagTable, PimItemFlagRelation") );
  statement.append( QLatin1String(" WHERE PimItemFlagRelation.PimItem_id = :key") );
  statement.append( QLatin1String(" AND PimItemFlagRelation.Flag_id = FlagTable.id") );

  query.prepare( statement );
  query.bindValue( QLatin1String(":key"), id() );
  if ( !query.exec() ) {
    qDebug() << "Error during selection of records from table PimItemFlagRelation"
      << query.lastError().text();
    return QVector<Flag>();
  }

  return Flag::extractResult( query );
}

// manipulate n:m relations
bool PimItem::relatesToFlag( const Flag & value ) const
{
  return Entity::relatesTo<PimItemFlagRelation>( id(), value.id() );
}

bool PimItem::relatesToFlag( qint64 leftId, qint64 rightId )
{
  return Entity::relatesTo<PimItemFlagRelation>( leftId, rightId );
}

bool PimItem::addFlag( const Flag & value ) const
{
  return Entity::addToRelation<PimItemFlagRelation>( id(), value.id() );
}

bool PimItem::addFlag( qint64 leftId, qint64 rightId )
{
  return Entity::addToRelation<PimItemFlagRelation>( leftId, rightId );
}

bool PimItem::removeFlag( const Flag & value ) const
{
  return Entity::removeFromRelation<PimItemFlagRelation>( id(), value.id() );
}

bool PimItem::removeFlag( qint64 leftId, qint64 rightId )
{
  return Entity::removeFromRelation<PimItemFlagRelation>( leftId, rightId );
}

bool PimItem::clearFlags() const
{
  return Entity::clearRelation<PimItemFlagRelation>( id() );
}

bool PimItem::clearFlags( qint64 id )
{
  return Entity::clearRelation<PimItemFlagRelation>( id );
}



// debug stream operator
QDebug & operator<<( QDebug& d, const PimItem& entity )
{
  d << "[PimItem: "
  
    << "id = " << entity.id()
    << ", "
    << "rev = " << entity.rev()
    << ", "
    << "remoteId = " << entity.remoteId()
    << ", "
    << "remoteRevision = " << entity.remoteRevision()
    << ", "
    << "collectionId = " << entity.collectionId()
    << ", "
    << "mimeTypeId = " << entity.mimeTypeId()
    << ", "
    << "datetime = " << entity.datetime()
    << ", "
    << "atime = " << entity.atime()
    << ", "
    << "dirty = " << entity.dirty()
    << ", "
    << "size = " << entity.size()
    
    << "]";
  return d;
}

// inserting new data
bool PimItem::insert( qint64* insertId )
{
  QSqlDatabase db = DataStore::self()->database();
  if ( !db.isOpen() )
    return false;

  QueryBuilder qb( tableName(), QueryBuilder::Insert );
  
    if ( d->rev_changed )
      qb.setColumnValue( revColumn(), this->rev() );
    
    if ( d->remoteId_changed )
      qb.setColumnValue( remoteIdColumn(), this->remoteId() );
    
    if ( d->remoteRevision_changed )
      qb.setColumnValue( remoteRevisionColumn(), this->remoteRevision() );
    
    if ( d->collectionId_changed  && d->collectionId > 0 )
      qb.setColumnValue( collectionIdColumn(), this->collectionId() );
    
    if ( d->mimeTypeId_changed  && d->mimeTypeId > 0 )
      qb.setColumnValue( mimeTypeIdColumn(), this->mimeTypeId() );
    
    if ( d->datetime_changed )
      qb.setColumnValue( datetimeColumn(), this->datetime() );
    
    if ( d->atime_changed )
      qb.setColumnValue( atimeColumn(), this->atime() );
    
    if ( d->dirty_changed )
      qb.setColumnValue( dirtyColumn(), this->dirty() );
    
    if ( d->size_changed )
      qb.setColumnValue( sizeColumn(), this->size() );
    

  if ( !qb.exec() ) {
    qDebug() << "Error during insertion into table" << tableName()
      << qb.query().lastError().text();
    return false;
  }

  setId( qb.insertId() );
  if ( insertId )
    *insertId = id();
  return true;
}

bool PimItem::hasPendingChanges() const
{
  return false
  
    || d->rev_changed
  
    || d->remoteId_changed
  
    || d->remoteRevision_changed
  
    || d->collectionId_changed
  
    || d->mimeTypeId_changed
  
    || d->datetime_changed
  
    || d->atime_changed
  
    || d->dirty_changed
  
    || d->size_changed
  ;
}

// update existing data
bool PimItem::update()
{
  invalidateCache();
  QSqlDatabase db = DataStore::self()->database();
  if ( !db.isOpen() )
    return false;

  QString statement = QLatin1String( "UPDATE " );
  statement += tableName();
  statement += QLatin1String( " SET " );

  QStringList cols;
  
    if ( d->rev_changed )
      cols.append( revColumn() + QLatin1String( " = :rev" ) );;
  
    if ( d->remoteId_changed )
      cols.append( remoteIdColumn() + QLatin1String( " = :remoteId" ) );;
  
    if ( d->remoteRevision_changed )
      cols.append( remoteRevisionColumn() + QLatin1String( " = :remoteRevision" ) );;
  
    if ( d->collectionId_changed )
      cols.append( collectionIdColumn() + QLatin1String( " = :collectionId" ) );;
  
    if ( d->mimeTypeId_changed )
      cols.append( mimeTypeIdColumn() + QLatin1String( " = :mimeTypeId" ) );;
  
    if ( d->datetime_changed )
      cols.append( datetimeColumn() + QLatin1String( " = :datetime" ) );;
  
    if ( d->atime_changed )
      cols.append( atimeColumn() + QLatin1String( " = :atime" ) );;
  
    if ( d->dirty_changed )
      cols.append( dirtyColumn() + QLatin1String( " = :dirty" ) );;
  
    if ( d->size_changed )
      cols.append( sizeColumn() + QLatin1String( " = :size" ) );;
  
  statement += cols.join( QLatin1String( ", " ) );
  
  statement += QLatin1String( " WHERE id = :id" );
  

  QSqlQuery query( db );
  query.prepare( statement );
  
    if ( d->rev_changed ) {
      
        query.bindValue( QLatin1String(":rev"), this->rev() );
    }
  
    if ( d->remoteId_changed ) {
      
        query.bindValue( QLatin1String(":remoteId"), this->remoteId() );
    }
  
    if ( d->remoteRevision_changed ) {
      
        query.bindValue( QLatin1String(":remoteRevision"), this->remoteRevision() );
    }
  
    if ( d->collectionId_changed ) {
      
      if ( d->collectionId <= 0 )
        query.bindValue( QLatin1String(":collectionId"), QVariant() );
      else
      
        query.bindValue( QLatin1String(":collectionId"), this->collectionId() );
    }
  
    if ( d->mimeTypeId_changed ) {
      
      if ( d->mimeTypeId <= 0 )
        query.bindValue( QLatin1String(":mimeTypeId"), QVariant() );
      else
      
        query.bindValue( QLatin1String(":mimeTypeId"), this->mimeTypeId() );
    }
  
    if ( d->datetime_changed ) {
      
        query.bindValue( QLatin1String(":datetime"), this->datetime() );
    }
  
    if ( d->atime_changed ) {
      
        query.bindValue( QLatin1String(":atime"), this->atime() );
    }
  
    if ( d->dirty_changed ) {
      
        query.bindValue( QLatin1String(":dirty"), this->dirty() );
    }
  
    if ( d->size_changed ) {
      
        query.bindValue( QLatin1String(":size"), this->size() );
    }
  
  query.bindValue( QLatin1String(":id"), id() );
  
  if ( !query.exec() ) {
    qDebug() << "Error during updating record with id" << id()
             << " in table" << tableName() << query.lastError().text();
    return false;
  }
  return true;
}

// delete records
bool PimItem::remove( const QString &column, const QVariant &value )
{
  invalidateCompleteCache();
  return Entity::remove<PimItem>( column, value );
}


bool PimItem::remove()
{
  invalidateCache();
  return Entity::remove<PimItem>( idColumn(), id() );
}

bool PimItem::remove( qint64 id )
{
  return remove( idColumn(), id );
}


// cache stuff
void PimItem::invalidateCache() const
{
  if ( Private::cacheEnabled ) {
    Private::cacheMutex.lock();
    
    Private::idCache.remove( id() );
    
    Private::cacheMutex.unlock();
  }
}

void PimItem::invalidateCompleteCache()
{
  if ( Private::cacheEnabled ) {
    Private::cacheMutex.lock();
    
    Private::idCache.clear();
    
    Private::cacheMutex.unlock();
  }
}

void PimItem::enableCache( bool enable )
{
  Private::cacheEnabled = enable;
}



// private class
class Flag::Private : public QSharedData
{
  public:
    Private() : QSharedData()
    
      , name()
    
      , name_changed( false )
    
    {}

    
    QString name;
    
    bool name_changed : 1;
    

    static void addToCache( const Flag & entry );

    // cache
    static bool cacheEnabled;
    static QMutex cacheMutex;
    
    static QHash<qint64, Flag > idCache;
    
    static QHash<QString, Flag > nameCache;
    
};


// static members
bool Flag::Private::cacheEnabled = false;
QMutex Flag::Private::cacheMutex;

QHash<qint64, Flag > Flag::Private::idCache;

QHash<QString, Flag > Flag::Private::nameCache;



void Flag::Private::addToCache( const Flag & entry )
{
  Q_ASSERT( cacheEnabled );
  Q_UNUSED( entry ); 
  cacheMutex.lock();
  
  idCache.insert( entry.id(), entry );
  
  nameCache.insert( entry.name(), entry );
  
  cacheMutex.unlock();
}


// constructor
Flag::Flag() : Entity(),
  d( new Private )
{
}

Flag::Flag(
  const QString &name
) :
  Entity(),
  d( new Private )
{

  d->name = name;
  d->name_changed = true;

}

Flag::Flag(
  qint64 id, const QString &name
) :
  Entity( id ),
  d( new Private )
{

  d->name = name;
  d->name_changed = true;

}
Flag::Flag( const Flag & other )
  : Entity( other ), d( other.d )
{
}

// destructor
Flag::~Flag() {}

// assignment operator
Flag& Flag::operator=( const Flag & other )
{
  if ( this != &other ) {
    d = other.d;
    setId( other.id() );
  }
  return *this;
}

// comparisson operator
bool Flag::operator==( const Flag & other )
{
  return id() == other.id();
}

// accessor methods
QString Flag::name() const
{
  return d->name;
}

void Flag::
setName( const QString &name )

{
  d->name = name;
  d->name_changed = true;
}



// SQL table information
QString Flag::tableName()
{
  return QLatin1String( "FlagTable" );
}

QStringList Flag::columnNames()
{
  QStringList rv;
  
  rv.append( QLatin1String( "id" ) );
  
  rv.append( QLatin1String( "name" ) );
  
  return rv;
}

QStringList Flag::fullColumnNames()
{
  QStringList rv;
  
  rv.append( QLatin1String( "FlagTable.id" ) );
  
  rv.append( QLatin1String( "FlagTable.name" ) );
  
  return rv;
}


QString Flag::idColumn()
{
  return QLatin1String( "id" );
}

QString Flag::idFullColumnName()
{
  return tableName() + QLatin1String( ".id" );
}

QString Flag::nameColumn()
{
  return QLatin1String( "name" );
}

QString Flag::nameFullColumnName()
{
  return tableName() + QLatin1String( ".name" );
}



// count records
int Flag::count( const QString &column, const QVariant &value )
{
  return Entity::count<Flag>( column, value );
}

// check existence

bool Flag::exists( qint64 id )
{
  if ( Private::cacheEnabled ) {
    Private::cacheMutex.lock();
    if ( Private::idCache.contains( id ) ) {
      Private::cacheMutex.unlock();
      return true;
    }
    Private::cacheMutex.unlock();
  }
  return count( idColumn(), id ) > 0;
}

bool Flag::exists( const QString &name )
{
  if ( Private::cacheEnabled ) {
    Private::cacheMutex.lock();
    if ( Private::nameCache.contains( name ) ) {
      Private::cacheMutex.unlock();
      return true;
    }
    Private::cacheMutex.unlock();
  }
  return count( nameColumn(), name ) > 0;
}



// result extraction
QVector< Flag > Flag::extractResult( QSqlQuery & query )
{
  QVector<Flag> rv;
  while ( query.next() ) {
    rv.append( Flag(
      
        (query.isNull(0)) ?
          qint64() :
          
          query.value( 0 ).value<qint64>()
            ,
        (query.isNull(1)) ?
          QString() :
          
          Utils::variantToString( query.value( 1 ) )
            
    ) );
  }
  return rv;
}

// data retrieval
Flag Flag::retrieveById( qint64 id )
{
  
  if ( Private::cacheEnabled ) {
    Private::cacheMutex.lock();
    if ( Private::idCache.contains( id ) ) {
      Private::cacheMutex.unlock();
      return Private::idCache.value( id );
    }
    Private::cacheMutex.unlock();
  }
  
  QSqlDatabase db = DataStore::self()->database();
  if ( !db.isOpen() )
    return Flag();

  QSqlQuery query( db );
  QString statement = QLatin1String( "SELECT id, name FROM " );
  statement.append( tableName() );
  statement.append( QLatin1String(" WHERE id = :key") );
  query.prepare( statement );
  query.bindValue( QLatin1String(":key"), id );
  if ( !query.exec() ) {
    qDebug() << "Error during selection of record with id"
      << id << "from table" << tableName()
      << query.lastError().text();
    return Flag();
  }
  if ( !query.next() ) {
    return Flag();
  }

  Flag rv(
  
    (query.isNull(0)) ?
      qint64() :
      
      query.value( 0 ).value<qint64>()
        ,
    (query.isNull(1)) ?
      QString() :
      
      Utils::variantToString( query.value( 1 ) )
        
  );
  if ( Private::cacheEnabled ) {
    Private::addToCache( rv );
  }
  return rv;

}

Flag Flag::retrieveByName( const QString &name )
{
  
  if ( Private::cacheEnabled ) {
    Private::cacheMutex.lock();
    if ( Private::nameCache.contains( name ) ) {
      Private::cacheMutex.unlock();
      return Private::nameCache.value( name );
    }
    Private::cacheMutex.unlock();
  }
  
  QSqlDatabase db = DataStore::self()->database();
  if ( !db.isOpen() )
    return Flag();

  QSqlQuery query( db );
  QString statement = QLatin1String( "SELECT id, name FROM " );
  statement.append( tableName() );
  statement.append( QLatin1String(" WHERE name = :key") );
  query.prepare( statement );
  query.bindValue( QLatin1String(":key"), name );
  if ( !query.exec() ) {
    qDebug() << "Error during selection of record with name"
      << name << "from table" << tableName()
      << query.lastError().text();
    return Flag();
  }
  if ( !query.next() ) {
    return Flag();
  }

  Flag rv(
  
    (query.isNull(0)) ?
      qint64() :
      
      query.value( 0 ).value<qint64>()
        ,
    (query.isNull(1)) ?
      QString() :
      
      Utils::variantToString( query.value( 1 ) )
        
  );
  if ( Private::cacheEnabled ) {
    Private::addToCache( rv );
  }
  return rv;

}


QVector<Flag> Flag::retrieveAll()
{
  QSqlDatabase db = DataStore::self()->database();
  if ( !db.isOpen() )
    return QVector<Flag>();

  QSqlQuery query( db );
  QString statement = QLatin1String( "SELECT id, name FROM " );
  statement.append( tableName() );
  query.prepare( statement );
  if ( !query.exec() ) {
    qDebug() << "Error during selection of all records from table" << tableName()
      << query.lastError().text();
    return QVector<Flag>();
  }
  return extractResult( query );
}

QVector<Flag> Flag::retrieveFiltered( const QString &key, const QVariant &value )
{
  QSqlDatabase db = DataStore::self()->database();
  if ( !db.isOpen() )
    return QVector<Flag>();

  SelectQueryBuilder<Flag> qb;
  if ( value.isNull() )
    qb.addValueCondition( key, Query::Is, QVariant() );
  else
    qb.addValueCondition( key, Query::Equals, value );
  if ( !qb.exec() ) {
    qDebug() << "Error during selection of records from table" << tableName()
      << "filtered by" << key << "=" << value
      << qb.query().lastError().text();
    return QVector<Flag>();
  }
  return qb.result();
}

// data retrieval for referenced tables


// data retrieval for inverse referenced tables


// debug stream operator
QDebug & operator<<( QDebug& d, const Flag& entity )
{
  d << "[Flag: "
  
    << "id = " << entity.id()
    << ", "
    << "name = " << entity.name()
    
    << "]";
  return d;
}

// inserting new data
bool Flag::insert( qint64* insertId )
{
  QSqlDatabase db = DataStore::self()->database();
  if ( !db.isOpen() )
    return false;

  QueryBuilder qb( tableName(), QueryBuilder::Insert );
  
    if ( d->name_changed )
      qb.setColumnValue( nameColumn(), this->name() );
    

  if ( !qb.exec() ) {
    qDebug() << "Error during insertion into table" << tableName()
      << qb.query().lastError().text();
    return false;
  }

  setId( qb.insertId() );
  if ( insertId )
    *insertId = id();
  return true;
}

bool Flag::hasPendingChanges() const
{
  return false
  
    || d->name_changed
  ;
}

// update existing data
bool Flag::update()
{
  invalidateCache();
  QSqlDatabase db = DataStore::self()->database();
  if ( !db.isOpen() )
    return false;

  QString statement = QLatin1String( "UPDATE " );
  statement += tableName();
  statement += QLatin1String( " SET " );

  QStringList cols;
  
    if ( d->name_changed )
      cols.append( nameColumn() + QLatin1String( " = :name" ) );;
  
  statement += cols.join( QLatin1String( ", " ) );
  
  statement += QLatin1String( " WHERE id = :id" );
  

  QSqlQuery query( db );
  query.prepare( statement );
  
    if ( d->name_changed ) {
      
        query.bindValue( QLatin1String(":name"), this->name() );
    }
  
  query.bindValue( QLatin1String(":id"), id() );
  
  if ( !query.exec() ) {
    qDebug() << "Error during updating record with id" << id()
             << " in table" << tableName() << query.lastError().text();
    return false;
  }
  return true;
}

// delete records
bool Flag::remove( const QString &column, const QVariant &value )
{
  invalidateCompleteCache();
  return Entity::remove<Flag>( column, value );
}


bool Flag::remove()
{
  invalidateCache();
  return Entity::remove<Flag>( idColumn(), id() );
}

bool Flag::remove( qint64 id )
{
  return remove( idColumn(), id );
}


// cache stuff
void Flag::invalidateCache() const
{
  if ( Private::cacheEnabled ) {
    Private::cacheMutex.lock();
    
    Private::idCache.remove( id() );
    
    Private::nameCache.remove( name() );
    
    Private::cacheMutex.unlock();
  }
}

void Flag::invalidateCompleteCache()
{
  if ( Private::cacheEnabled ) {
    Private::cacheMutex.lock();
    
    Private::idCache.clear();
    
    Private::nameCache.clear();
    
    Private::cacheMutex.unlock();
  }
}

void Flag::enableCache( bool enable )
{
  Private::cacheEnabled = enable;
}



// private class
class Part::Private : public QSharedData
{
  public:
    Private() : QSharedData()
    
      , pimItemId( 0 )
    
      , datasize( 0 )
    
      , name()
    
      , data()
    
      , version( 0 )
    
      , external( false )
    
      , pimItemId_changed( false )
    
      , name_changed( false )
    
      , data_changed( false )
    
      , datasize_changed( false )
    
      , version_changed( false )
    
      , external_changed( false )
    
    {}

    
    qint64 pimItemId;
    
    qint64 datasize;
    
    QString name;
    
    QByteArray data;
    
    int version;
    
    bool external : 1;
    
    bool pimItemId_changed : 1;
    
    bool name_changed : 1;
    
    bool data_changed : 1;
    
    bool datasize_changed : 1;
    
    bool version_changed : 1;
    
    bool external_changed : 1;
    

    static void addToCache( const Part & entry );

    // cache
    static bool cacheEnabled;
    static QMutex cacheMutex;
    
    static QHash<qint64, Part > idCache;
    
    static QHash<QString, Part > nameCache;
    
};


// static members
bool Part::Private::cacheEnabled = false;
QMutex Part::Private::cacheMutex;

QHash<qint64, Part > Part::Private::idCache;

QHash<QString, Part > Part::Private::nameCache;



void Part::Private::addToCache( const Part & entry )
{
  Q_ASSERT( cacheEnabled );
  Q_UNUSED( entry ); 
  cacheMutex.lock();
  
  idCache.insert( entry.id(), entry );
  
  nameCache.insert( entry.name(), entry );
  
  cacheMutex.unlock();
}


// constructor
Part::Part() : Entity(),
  d( new Private )
{
}

Part::Part(
  qint64 pimItemId, const QString &name, const QByteArray &data, qint64 datasize, int version, bool external
) :
  Entity(),
  d( new Private )
{

  d->pimItemId = pimItemId;
  d->pimItemId_changed = true;

  d->name = name;
  d->name_changed = true;

  d->data = data;
  d->data_changed = true;

  d->datasize = datasize;
  d->datasize_changed = true;

  d->version = version;
  d->version_changed = true;

  d->external = external;
  d->external_changed = true;

}

Part::Part(
  qint64 id, qint64 pimItemId, const QString &name, const QByteArray &data, qint64 datasize, int version, bool external
) :
  Entity( id ),
  d( new Private )
{

  d->pimItemId = pimItemId;
  d->pimItemId_changed = true;

  d->name = name;
  d->name_changed = true;

  d->data = data;
  d->data_changed = true;

  d->datasize = datasize;
  d->datasize_changed = true;

  d->version = version;
  d->version_changed = true;

  d->external = external;
  d->external_changed = true;

}
Part::Part( const Part & other )
  : Entity( other ), d( other.d )
{
}

// destructor
Part::~Part() {}

// assignment operator
Part& Part::operator=( const Part & other )
{
  if ( this != &other ) {
    d = other.d;
    setId( other.id() );
  }
  return *this;
}

// comparisson operator
bool Part::operator==( const Part & other )
{
  return id() == other.id();
}

// accessor methods
qint64 Part::pimItemId() const
{
  return d->pimItemId;
}

void Part::
setPimItemId( qint64 pimItemId )

{
  d->pimItemId = pimItemId;
  d->pimItemId_changed = true;
}

QString Part::name() const
{
  return d->name;
}

void Part::
setName( const QString &name )

{
  d->name = name;
  d->name_changed = true;
}

QByteArray Part::data() const
{
  return d->data;
}

void Part::
setData( const QByteArray &data )

{
  d->data = data;
  d->data_changed = true;
}

qint64 Part::datasize() const
{
  return d->datasize;
}

void Part::
setDatasize( qint64 datasize )

{
  d->datasize = datasize;
  d->datasize_changed = true;
}

int Part::version() const
{
  return d->version;
}

void Part::
setVersion( int version )

{
  d->version = version;
  d->version_changed = true;
}

bool Part::external() const
{
  return d->external;
}

void Part::
setExternal( bool external )

{
  d->external = external;
  d->external_changed = true;
}



// SQL table information
QString Part::tableName()
{
  return QLatin1String( "PartTable" );
}

QStringList Part::columnNames()
{
  QStringList rv;
  
  rv.append( QLatin1String( "id" ) );
  
  rv.append( QLatin1String( "pimItemId" ) );
  
  rv.append( QLatin1String( "name" ) );
  
  rv.append( QLatin1String( "data" ) );
  
  rv.append( QLatin1String( "datasize" ) );
  
  rv.append( QLatin1String( "version" ) );
  
  rv.append( QLatin1String( "external" ) );
  
  return rv;
}

QStringList Part::fullColumnNames()
{
  QStringList rv;
  
  rv.append( QLatin1String( "PartTable.id" ) );
  
  rv.append( QLatin1String( "PartTable.pimItemId" ) );
  
  rv.append( QLatin1String( "PartTable.name" ) );
  
  rv.append( QLatin1String( "PartTable.data" ) );
  
  rv.append( QLatin1String( "PartTable.datasize" ) );
  
  rv.append( QLatin1String( "PartTable.version" ) );
  
  rv.append( QLatin1String( "PartTable.external" ) );
  
  return rv;
}


QString Part::idColumn()
{
  return QLatin1String( "id" );
}

QString Part::idFullColumnName()
{
  return tableName() + QLatin1String( ".id" );
}

QString Part::pimItemIdColumn()
{
  return QLatin1String( "pimItemId" );
}

QString Part::pimItemIdFullColumnName()
{
  return tableName() + QLatin1String( ".pimItemId" );
}

QString Part::nameColumn()
{
  return QLatin1String( "name" );
}

QString Part::nameFullColumnName()
{
  return tableName() + QLatin1String( ".name" );
}

QString Part::dataColumn()
{
  return QLatin1String( "data" );
}

QString Part::dataFullColumnName()
{
  return tableName() + QLatin1String( ".data" );
}

QString Part::datasizeColumn()
{
  return QLatin1String( "datasize" );
}

QString Part::datasizeFullColumnName()
{
  return tableName() + QLatin1String( ".datasize" );
}

QString Part::versionColumn()
{
  return QLatin1String( "version" );
}

QString Part::versionFullColumnName()
{
  return tableName() + QLatin1String( ".version" );
}

QString Part::externalColumn()
{
  return QLatin1String( "external" );
}

QString Part::externalFullColumnName()
{
  return tableName() + QLatin1String( ".external" );
}



// count records
int Part::count( const QString &column, const QVariant &value )
{
  return Entity::count<Part>( column, value );
}

// check existence

bool Part::exists( qint64 id )
{
  if ( Private::cacheEnabled ) {
    Private::cacheMutex.lock();
    if ( Private::idCache.contains( id ) ) {
      Private::cacheMutex.unlock();
      return true;
    }
    Private::cacheMutex.unlock();
  }
  return count( idColumn(), id ) > 0;
}

bool Part::exists( const QString &name )
{
  if ( Private::cacheEnabled ) {
    Private::cacheMutex.lock();
    if ( Private::nameCache.contains( name ) ) {
      Private::cacheMutex.unlock();
      return true;
    }
    Private::cacheMutex.unlock();
  }
  return count( nameColumn(), name ) > 0;
}



// result extraction
QVector< Part > Part::extractResult( QSqlQuery & query )
{
  QVector<Part> rv;
  while ( query.next() ) {
    rv.append( Part(
      
        (query.isNull(0)) ?
          qint64() :
          
          query.value( 0 ).value<qint64>()
            ,
        (query.isNull(1)) ?
          qint64() :
          
          query.value( 1 ).value<qint64>()
            ,
        (query.isNull(2)) ?
          QString() :
          
          Utils::variantToString( query.value( 2 ) )
            ,
        (query.isNull(3)) ?
          QByteArray() :
          
          query.value( 3 ).value<QByteArray>()
            ,
        (query.isNull(4)) ?
          qint64() :
          
          query.value( 4 ).value<qint64>()
            ,
        (query.isNull(5)) ?
          int() :
          
          query.value( 5 ).value<int>()
            ,
        (query.isNull(6)) ?
          bool() :
          
          query.value( 6 ).value<bool>()
            
    ) );
  }
  return rv;
}

// data retrieval
Part Part::retrieveById( qint64 id )
{
  
  if ( Private::cacheEnabled ) {
    Private::cacheMutex.lock();
    if ( Private::idCache.contains( id ) ) {
      Private::cacheMutex.unlock();
      return Private::idCache.value( id );
    }
    Private::cacheMutex.unlock();
  }
  
  QSqlDatabase db = DataStore::self()->database();
  if ( !db.isOpen() )
    return Part();

  QSqlQuery query( db );
  QString statement = QLatin1String( "SELECT id, pimItemId, name, data, datasize, version, external FROM " );
  statement.append( tableName() );
  statement.append( QLatin1String(" WHERE id = :key") );
  query.prepare( statement );
  query.bindValue( QLatin1String(":key"), id );
  if ( !query.exec() ) {
    qDebug() << "Error during selection of record with id"
      << id << "from table" << tableName()
      << query.lastError().text();
    return Part();
  }
  if ( !query.next() ) {
    return Part();
  }

  Part rv(
  
    (query.isNull(0)) ?
      qint64() :
      
      query.value( 0 ).value<qint64>()
        ,
    (query.isNull(1)) ?
      qint64() :
      
      query.value( 1 ).value<qint64>()
        ,
    (query.isNull(2)) ?
      QString() :
      
      Utils::variantToString( query.value( 2 ) )
        ,
    (query.isNull(3)) ?
      QByteArray() :
      
      query.value( 3 ).value<QByteArray>()
        ,
    (query.isNull(4)) ?
      qint64() :
      
      query.value( 4 ).value<qint64>()
        ,
    (query.isNull(5)) ?
      int() :
      
      query.value( 5 ).value<int>()
        ,
    (query.isNull(6)) ?
      bool() :
      
      query.value( 6 ).value<bool>()
        
  );
  if ( Private::cacheEnabled ) {
    Private::addToCache( rv );
  }
  return rv;

}

Part Part::retrieveByName( const QString &name )
{
  
  if ( Private::cacheEnabled ) {
    Private::cacheMutex.lock();
    if ( Private::nameCache.contains( name ) ) {
      Private::cacheMutex.unlock();
      return Private::nameCache.value( name );
    }
    Private::cacheMutex.unlock();
  }
  
  QSqlDatabase db = DataStore::self()->database();
  if ( !db.isOpen() )
    return Part();

  QSqlQuery query( db );
  QString statement = QLatin1String( "SELECT id, pimItemId, name, data, datasize, version, external FROM " );
  statement.append( tableName() );
  statement.append( QLatin1String(" WHERE name = :key") );
  query.prepare( statement );
  query.bindValue( QLatin1String(":key"), name );
  if ( !query.exec() ) {
    qDebug() << "Error during selection of record with name"
      << name << "from table" << tableName()
      << query.lastError().text();
    return Part();
  }
  if ( !query.next() ) {
    return Part();
  }

  Part rv(
  
    (query.isNull(0)) ?
      qint64() :
      
      query.value( 0 ).value<qint64>()
        ,
    (query.isNull(1)) ?
      qint64() :
      
      query.value( 1 ).value<qint64>()
        ,
    (query.isNull(2)) ?
      QString() :
      
      Utils::variantToString( query.value( 2 ) )
        ,
    (query.isNull(3)) ?
      QByteArray() :
      
      query.value( 3 ).value<QByteArray>()
        ,
    (query.isNull(4)) ?
      qint64() :
      
      query.value( 4 ).value<qint64>()
        ,
    (query.isNull(5)) ?
      int() :
      
      query.value( 5 ).value<int>()
        ,
    (query.isNull(6)) ?
      bool() :
      
      query.value( 6 ).value<bool>()
        
  );
  if ( Private::cacheEnabled ) {
    Private::addToCache( rv );
  }
  return rv;

}


QVector<Part> Part::retrieveAll()
{
  QSqlDatabase db = DataStore::self()->database();
  if ( !db.isOpen() )
    return QVector<Part>();

  QSqlQuery query( db );
  QString statement = QLatin1String( "SELECT id, pimItemId, name, data, datasize, version, external FROM " );
  statement.append( tableName() );
  query.prepare( statement );
  if ( !query.exec() ) {
    qDebug() << "Error during selection of all records from table" << tableName()
      << query.lastError().text();
    return QVector<Part>();
  }
  return extractResult( query );
}

QVector<Part> Part::retrieveFiltered( const QString &key, const QVariant &value )
{
  QSqlDatabase db = DataStore::self()->database();
  if ( !db.isOpen() )
    return QVector<Part>();

  SelectQueryBuilder<Part> qb;
  if ( value.isNull() )
    qb.addValueCondition( key, Query::Is, QVariant() );
  else
    qb.addValueCondition( key, Query::Equals, value );
  if ( !qb.exec() ) {
    qDebug() << "Error during selection of records from table" << tableName()
      << "filtered by" << key << "=" << value
      << qb.query().lastError().text();
    return QVector<Part>();
  }
  return qb.result();
}

// data retrieval for referenced tables
PimItem Part::pimItem() const
{
  return PimItem::retrieveById( pimItemId() );

}


// data retrieval for inverse referenced tables


// debug stream operator
QDebug & operator<<( QDebug& d, const Part& entity )
{
  d << "[Part: "
  
    << "id = " << entity.id()
    << ", "
    << "pimItemId = " << entity.pimItemId()
    << ", "
    << "name = " << entity.name()
    << ", "
    << "data = " << entity.data()
    << ", "
    << "datasize = " << entity.datasize()
    << ", "
    << "version = " << entity.version()
    << ", "
    << "external = " << entity.external()
    
    << "]";
  return d;
}

// inserting new data
bool Part::insert( qint64* insertId )
{
  QSqlDatabase db = DataStore::self()->database();
  if ( !db.isOpen() )
    return false;

  QueryBuilder qb( tableName(), QueryBuilder::Insert );
  
    if ( d->pimItemId_changed  && d->pimItemId > 0 )
      qb.setColumnValue( pimItemIdColumn(), this->pimItemId() );
    
    if ( d->name_changed )
      qb.setColumnValue( nameColumn(), this->name() );
    
    if ( d->data_changed )
      qb.setColumnValue( dataColumn(), this->data() );
    
    if ( d->datasize_changed )
      qb.setColumnValue( datasizeColumn(), this->datasize() );
    
    if ( d->version_changed )
      qb.setColumnValue( versionColumn(), this->version() );
    
    if ( d->external_changed )
      qb.setColumnValue( externalColumn(), this->external() );
    

  if ( !qb.exec() ) {
    qDebug() << "Error during insertion into table" << tableName()
      << qb.query().lastError().text();
    return false;
  }

  setId( qb.insertId() );
  if ( insertId )
    *insertId = id();
  return true;
}

bool Part::hasPendingChanges() const
{
  return false
  
    || d->pimItemId_changed
  
    || d->name_changed
  
    || d->data_changed
  
    || d->datasize_changed
  
    || d->version_changed
  
    || d->external_changed
  ;
}

// update existing data
bool Part::update()
{
  invalidateCache();
  QSqlDatabase db = DataStore::self()->database();
  if ( !db.isOpen() )
    return false;

  QString statement = QLatin1String( "UPDATE " );
  statement += tableName();
  statement += QLatin1String( " SET " );

  QStringList cols;
  
    if ( d->pimItemId_changed )
      cols.append( pimItemIdColumn() + QLatin1String( " = :pimItemId" ) );;
  
    if ( d->name_changed )
      cols.append( nameColumn() + QLatin1String( " = :name" ) );;
  
    if ( d->data_changed )
      cols.append( dataColumn() + QLatin1String( " = :data" ) );;
  
    if ( d->datasize_changed )
      cols.append( datasizeColumn() + QLatin1String( " = :datasize" ) );;
  
    if ( d->version_changed )
      cols.append( versionColumn() + QLatin1String( " = :version" ) );;
  
    if ( d->external_changed )
      cols.append( externalColumn() + QLatin1String( " = :external" ) );;
  
  statement += cols.join( QLatin1String( ", " ) );
  
  statement += QLatin1String( " WHERE id = :id" );
  

  QSqlQuery query( db );
  query.prepare( statement );
  
    if ( d->pimItemId_changed ) {
      
      if ( d->pimItemId <= 0 )
        query.bindValue( QLatin1String(":pimItemId"), QVariant() );
      else
      
        query.bindValue( QLatin1String(":pimItemId"), this->pimItemId() );
    }
  
    if ( d->name_changed ) {
      
        query.bindValue( QLatin1String(":name"), this->name() );
    }
  
    if ( d->data_changed ) {
      
        query.bindValue( QLatin1String(":data"), this->data() );
    }
  
    if ( d->datasize_changed ) {
      
        query.bindValue( QLatin1String(":datasize"), this->datasize() );
    }
  
    if ( d->version_changed ) {
      
        query.bindValue( QLatin1String(":version"), this->version() );
    }
  
    if ( d->external_changed ) {
      
        query.bindValue( QLatin1String(":external"), this->external() );
    }
  
  query.bindValue( QLatin1String(":id"), id() );
  
  if ( !query.exec() ) {
    qDebug() << "Error during updating record with id" << id()
             << " in table" << tableName() << query.lastError().text();
    return false;
  }
  return true;
}

// delete records
bool Part::remove( const QString &column, const QVariant &value )
{
  invalidateCompleteCache();
  return Entity::remove<Part>( column, value );
}


bool Part::remove()
{
  invalidateCache();
  return Entity::remove<Part>( idColumn(), id() );
}

bool Part::remove( qint64 id )
{
  return remove( idColumn(), id );
}


// cache stuff
void Part::invalidateCache() const
{
  if ( Private::cacheEnabled ) {
    Private::cacheMutex.lock();
    
    Private::idCache.remove( id() );
    
    Private::nameCache.remove( name() );
    
    Private::cacheMutex.unlock();
  }
}

void Part::invalidateCompleteCache()
{
  if ( Private::cacheEnabled ) {
    Private::cacheMutex.lock();
    
    Private::idCache.clear();
    
    Private::nameCache.clear();
    
    Private::cacheMutex.unlock();
  }
}

void Part::enableCache( bool enable )
{
  Private::cacheEnabled = enable;
}



// private class
class CollectionAttribute::Private : public QSharedData
{
  public:
    Private() : QSharedData()
    
      , collectionId( 0 )
    
      , type()
    
      , value()
    
      , collectionId_changed( false )
    
      , type_changed( false )
    
      , value_changed( false )
    
    {}

    
    qint64 collectionId;
    
    QByteArray type;
    
    QByteArray value;
    
    bool collectionId_changed : 1;
    
    bool type_changed : 1;
    
    bool value_changed : 1;
    

    static void addToCache( const CollectionAttribute & entry );

    // cache
    static bool cacheEnabled;
    static QMutex cacheMutex;
    
    static QHash<qint64, CollectionAttribute > idCache;
    
};


// static members
bool CollectionAttribute::Private::cacheEnabled = false;
QMutex CollectionAttribute::Private::cacheMutex;

QHash<qint64, CollectionAttribute > CollectionAttribute::Private::idCache;



void CollectionAttribute::Private::addToCache( const CollectionAttribute & entry )
{
  Q_ASSERT( cacheEnabled );
  Q_UNUSED( entry ); 
  cacheMutex.lock();
  
  idCache.insert( entry.id(), entry );
  
  cacheMutex.unlock();
}


// constructor
CollectionAttribute::CollectionAttribute() : Entity(),
  d( new Private )
{
}

CollectionAttribute::CollectionAttribute(
  qint64 collectionId, const QByteArray &type, const QByteArray &value
) :
  Entity(),
  d( new Private )
{

  d->collectionId = collectionId;
  d->collectionId_changed = true;

  d->type = type;
  d->type_changed = true;

  d->value = value;
  d->value_changed = true;

}

CollectionAttribute::CollectionAttribute(
  qint64 id, qint64 collectionId, const QByteArray &type, const QByteArray &value
) :
  Entity( id ),
  d( new Private )
{

  d->collectionId = collectionId;
  d->collectionId_changed = true;

  d->type = type;
  d->type_changed = true;

  d->value = value;
  d->value_changed = true;

}
CollectionAttribute::CollectionAttribute( const CollectionAttribute & other )
  : Entity( other ), d( other.d )
{
}

// destructor
CollectionAttribute::~CollectionAttribute() {}

// assignment operator
CollectionAttribute& CollectionAttribute::operator=( const CollectionAttribute & other )
{
  if ( this != &other ) {
    d = other.d;
    setId( other.id() );
  }
  return *this;
}

// comparisson operator
bool CollectionAttribute::operator==( const CollectionAttribute & other )
{
  return id() == other.id();
}

// accessor methods
qint64 CollectionAttribute::collectionId() const
{
  return d->collectionId;
}

void CollectionAttribute::
setCollectionId( qint64 collectionId )

{
  d->collectionId = collectionId;
  d->collectionId_changed = true;
}

QByteArray CollectionAttribute::type() const
{
  return d->type;
}

void CollectionAttribute::
setType( const QByteArray &type )

{
  d->type = type;
  d->type_changed = true;
}

QByteArray CollectionAttribute::value() const
{
  return d->value;
}

void CollectionAttribute::
setValue( const QByteArray &value )

{
  d->value = value;
  d->value_changed = true;
}



// SQL table information
QString CollectionAttribute::tableName()
{
  return QLatin1String( "CollectionAttributeTable" );
}

QStringList CollectionAttribute::columnNames()
{
  QStringList rv;
  
  rv.append( QLatin1String( "id" ) );
  
  rv.append( QLatin1String( "collectionId" ) );
  
  rv.append( QLatin1String( "type" ) );
  
  rv.append( QLatin1String( "value" ) );
  
  return rv;
}

QStringList CollectionAttribute::fullColumnNames()
{
  QStringList rv;
  
  rv.append( QLatin1String( "CollectionAttributeTable.id" ) );
  
  rv.append( QLatin1String( "CollectionAttributeTable.collectionId" ) );
  
  rv.append( QLatin1String( "CollectionAttributeTable.type" ) );
  
  rv.append( QLatin1String( "CollectionAttributeTable.value" ) );
  
  return rv;
}


QString CollectionAttribute::idColumn()
{
  return QLatin1String( "id" );
}

QString CollectionAttribute::idFullColumnName()
{
  return tableName() + QLatin1String( ".id" );
}

QString CollectionAttribute::collectionIdColumn()
{
  return QLatin1String( "collectionId" );
}

QString CollectionAttribute::collectionIdFullColumnName()
{
  return tableName() + QLatin1String( ".collectionId" );
}

QString CollectionAttribute::typeColumn()
{
  return QLatin1String( "type" );
}

QString CollectionAttribute::typeFullColumnName()
{
  return tableName() + QLatin1String( ".type" );
}

QString CollectionAttribute::valueColumn()
{
  return QLatin1String( "value" );
}

QString CollectionAttribute::valueFullColumnName()
{
  return tableName() + QLatin1String( ".value" );
}



// count records
int CollectionAttribute::count( const QString &column, const QVariant &value )
{
  return Entity::count<CollectionAttribute>( column, value );
}

// check existence

bool CollectionAttribute::exists( qint64 id )
{
  if ( Private::cacheEnabled ) {
    Private::cacheMutex.lock();
    if ( Private::idCache.contains( id ) ) {
      Private::cacheMutex.unlock();
      return true;
    }
    Private::cacheMutex.unlock();
  }
  return count( idColumn(), id ) > 0;
}



// result extraction
QVector< CollectionAttribute > CollectionAttribute::extractResult( QSqlQuery & query )
{
  QVector<CollectionAttribute> rv;
  while ( query.next() ) {
    rv.append( CollectionAttribute(
      
        (query.isNull(0)) ?
          qint64() :
          
          query.value( 0 ).value<qint64>()
            ,
        (query.isNull(1)) ?
          qint64() :
          
          query.value( 1 ).value<qint64>()
            ,
        (query.isNull(2)) ?
          QByteArray() :
          
          query.value( 2 ).value<QByteArray>()
            ,
        (query.isNull(3)) ?
          QByteArray() :
          
          query.value( 3 ).value<QByteArray>()
            
    ) );
  }
  return rv;
}

// data retrieval
CollectionAttribute CollectionAttribute::retrieveById( qint64 id )
{
  
  if ( Private::cacheEnabled ) {
    Private::cacheMutex.lock();
    if ( Private::idCache.contains( id ) ) {
      Private::cacheMutex.unlock();
      return Private::idCache.value( id );
    }
    Private::cacheMutex.unlock();
  }
  
  QSqlDatabase db = DataStore::self()->database();
  if ( !db.isOpen() )
    return CollectionAttribute();

  QSqlQuery query( db );
  QString statement = QLatin1String( "SELECT id, collectionId, type, value FROM " );
  statement.append( tableName() );
  statement.append( QLatin1String(" WHERE id = :key") );
  query.prepare( statement );
  query.bindValue( QLatin1String(":key"), id );
  if ( !query.exec() ) {
    qDebug() << "Error during selection of record with id"
      << id << "from table" << tableName()
      << query.lastError().text();
    return CollectionAttribute();
  }
  if ( !query.next() ) {
    return CollectionAttribute();
  }

  CollectionAttribute rv(
  
    (query.isNull(0)) ?
      qint64() :
      
      query.value( 0 ).value<qint64>()
        ,
    (query.isNull(1)) ?
      qint64() :
      
      query.value( 1 ).value<qint64>()
        ,
    (query.isNull(2)) ?
      QByteArray() :
      
      query.value( 2 ).value<QByteArray>()
        ,
    (query.isNull(3)) ?
      QByteArray() :
      
      query.value( 3 ).value<QByteArray>()
        
  );
  if ( Private::cacheEnabled ) {
    Private::addToCache( rv );
  }
  return rv;

}



QVector<CollectionAttribute> CollectionAttribute::retrieveAll()
{
  QSqlDatabase db = DataStore::self()->database();
  if ( !db.isOpen() )
    return QVector<CollectionAttribute>();

  QSqlQuery query( db );
  QString statement = QLatin1String( "SELECT id, collectionId, type, value FROM " );
  statement.append( tableName() );
  query.prepare( statement );
  if ( !query.exec() ) {
    qDebug() << "Error during selection of all records from table" << tableName()
      << query.lastError().text();
    return QVector<CollectionAttribute>();
  }
  return extractResult( query );
}

QVector<CollectionAttribute> CollectionAttribute::retrieveFiltered( const QString &key, const QVariant &value )
{
  QSqlDatabase db = DataStore::self()->database();
  if ( !db.isOpen() )
    return QVector<CollectionAttribute>();

  SelectQueryBuilder<CollectionAttribute> qb;
  if ( value.isNull() )
    qb.addValueCondition( key, Query::Is, QVariant() );
  else
    qb.addValueCondition( key, Query::Equals, value );
  if ( !qb.exec() ) {
    qDebug() << "Error during selection of records from table" << tableName()
      << "filtered by" << key << "=" << value
      << qb.query().lastError().text();
    return QVector<CollectionAttribute>();
  }
  return qb.result();
}

// data retrieval for referenced tables
Collection CollectionAttribute::collection() const
{
  return Collection::retrieveById( collectionId() );

}


// data retrieval for inverse referenced tables


// debug stream operator
QDebug & operator<<( QDebug& d, const CollectionAttribute& entity )
{
  d << "[CollectionAttribute: "
  
    << "id = " << entity.id()
    << ", "
    << "collectionId = " << entity.collectionId()
    << ", "
    << "type = " << entity.type()
    << ", "
    << "value = " << entity.value()
    
    << "]";
  return d;
}

// inserting new data
bool CollectionAttribute::insert( qint64* insertId )
{
  QSqlDatabase db = DataStore::self()->database();
  if ( !db.isOpen() )
    return false;

  QueryBuilder qb( tableName(), QueryBuilder::Insert );
  
    if ( d->collectionId_changed  && d->collectionId > 0 )
      qb.setColumnValue( collectionIdColumn(), this->collectionId() );
    
    if ( d->type_changed )
      qb.setColumnValue( typeColumn(), this->type() );
    
    if ( d->value_changed )
      qb.setColumnValue( valueColumn(), this->value() );
    

  if ( !qb.exec() ) {
    qDebug() << "Error during insertion into table" << tableName()
      << qb.query().lastError().text();
    return false;
  }

  setId( qb.insertId() );
  if ( insertId )
    *insertId = id();
  return true;
}

bool CollectionAttribute::hasPendingChanges() const
{
  return false
  
    || d->collectionId_changed
  
    || d->type_changed
  
    || d->value_changed
  ;
}

// update existing data
bool CollectionAttribute::update()
{
  invalidateCache();
  QSqlDatabase db = DataStore::self()->database();
  if ( !db.isOpen() )
    return false;

  QString statement = QLatin1String( "UPDATE " );
  statement += tableName();
  statement += QLatin1String( " SET " );

  QStringList cols;
  
    if ( d->collectionId_changed )
      cols.append( collectionIdColumn() + QLatin1String( " = :collectionId" ) );;
  
    if ( d->type_changed )
      cols.append( typeColumn() + QLatin1String( " = :type" ) );;
  
    if ( d->value_changed )
      cols.append( valueColumn() + QLatin1String( " = :value" ) );;
  
  statement += cols.join( QLatin1String( ", " ) );
  
  statement += QLatin1String( " WHERE id = :id" );
  

  QSqlQuery query( db );
  query.prepare( statement );
  
    if ( d->collectionId_changed ) {
      
      if ( d->collectionId <= 0 )
        query.bindValue( QLatin1String(":collectionId"), QVariant() );
      else
      
        query.bindValue( QLatin1String(":collectionId"), this->collectionId() );
    }
  
    if ( d->type_changed ) {
      
        query.bindValue( QLatin1String(":type"), this->type() );
    }
  
    if ( d->value_changed ) {
      
        query.bindValue( QLatin1String(":value"), this->value() );
    }
  
  query.bindValue( QLatin1String(":id"), id() );
  
  if ( !query.exec() ) {
    qDebug() << "Error during updating record with id" << id()
             << " in table" << tableName() << query.lastError().text();
    return false;
  }
  return true;
}

// delete records
bool CollectionAttribute::remove( const QString &column, const QVariant &value )
{
  invalidateCompleteCache();
  return Entity::remove<CollectionAttribute>( column, value );
}


bool CollectionAttribute::remove()
{
  invalidateCache();
  return Entity::remove<CollectionAttribute>( idColumn(), id() );
}

bool CollectionAttribute::remove( qint64 id )
{
  return remove( idColumn(), id );
}


// cache stuff
void CollectionAttribute::invalidateCache() const
{
  if ( Private::cacheEnabled ) {
    Private::cacheMutex.lock();
    
    Private::idCache.remove( id() );
    
    Private::cacheMutex.unlock();
  }
}

void CollectionAttribute::invalidateCompleteCache()
{
  if ( Private::cacheEnabled ) {
    Private::cacheMutex.lock();
    
    Private::idCache.clear();
    
    Private::cacheMutex.unlock();
  }
}

void CollectionAttribute::enableCache( bool enable )
{
  Private::cacheEnabled = enable;
}



// SQL table information
QString PimItemFlagRelation::tableName()
{
  return QLatin1String( "PimItemFlagRelation" );
}

QString PimItemFlagRelation::leftColumn()
{
  return QLatin1String( "PimItem_id" );
}

QString PimItemFlagRelation::leftFullColumnName()
{
  return tableName() + QLatin1String( "." ) + leftColumn();
}

QString PimItemFlagRelation::rightColumn()
{
  return QLatin1String( "Flag_id" );
}

QString PimItemFlagRelation::rightFullColumnName()
{
  return tableName() + QLatin1String( "." ) + rightColumn();
}


// SQL table information
QString CollectionMimeTypeRelation::tableName()
{
  return QLatin1String( "CollectionMimeTypeRelation" );
}

QString CollectionMimeTypeRelation::leftColumn()
{
  return QLatin1String( "Collection_id" );
}

QString CollectionMimeTypeRelation::leftFullColumnName()
{
  return tableName() + QLatin1String( "." ) + leftColumn();
}

QString CollectionMimeTypeRelation::rightColumn()
{
  return QLatin1String( "MimeType_id" );
}

QString CollectionMimeTypeRelation::rightFullColumnName()
{
  return tableName() + QLatin1String( "." ) + rightColumn();
}


// SQL table information
QString CollectionPimItemRelation::tableName()
{
  return QLatin1String( "CollectionPimItemRelation" );
}

QString CollectionPimItemRelation::leftColumn()
{
  return QLatin1String( "Collection_id" );
}

QString CollectionPimItemRelation::leftFullColumnName()
{
  return tableName() + QLatin1String( "." ) + leftColumn();
}

QString CollectionPimItemRelation::rightColumn()
{
  return QLatin1String( "PimItem_id" );
}

QString CollectionPimItemRelation::rightFullColumnName()
{
  return tableName() + QLatin1String( "." ) + rightColumn();
}
